<?php if(!defined('BASEPATH')) exit('No direct script access allowed');
class MY_Admin_Controller extends MY_Controller
{
	function __construct()
	{
		parent::__construct();
		$data = array();
		//$is_logged_in = $this->session->userdata('is_logged_in');
		$this->adminid = $this->session->userdata('adminid');
		$this->admintype = $this->session->userdata('admin_type');
		$this->adminname = $this->session->userdata('admin_name');
		$this->search_table = ($this->session->userdata('search_table')!="")?$this->session->userdata('search_table'):"user";
		$this->load->model("admin/admin_model","admin");
		$this->load->model("email_alerts/email_alerts_model","alert");
		$this->load->model("global_tender/global_tender_model","tender");
		$this->load->model("tender_search/tender_search_model","search");
		$this->load->model("global_tender_dashboard/global_tender_dashboard_model","dashboard");
		$this->load->model("tender_login/login_model","login");
        $this->load->model("user_search/user_search_model","usearch");
        $this->load->model("tenders_templates/Tenders_templates_model","templates");
		$this->load->model("report/report_model","report");
		$this->load->helper('admin_helper');
		$this->load->helper('email_alert_helper');
		$this->load->library('image_lib');
		$this->load->library("pag");
		$this->load->library('pagination');
		$this->load->helper('file');
        $this->load->library('PHPExcel');
        $this->load->library('PHPExcel/IOFactory');
		$this->perPage = ($this->session->userdata("tender_admin_length")?$this->session->userdata("tender_admin_length"):10);
	}

    public function tenderAdminSearchLength()
    {
        $this->session->set_userdata(array("tender_admin_length"=>$_POST['length']));
        echo 1;
    }

	public function addCategory()
	{
		if(isset($_POST['addcategory']))
		{
			/*if($this->common->getData('category',array('category'=>$_POST['category'])))
			{
				$this->session->set_flashdata('emessage',$this->lang->line("category_exist"));
			}else{*/
				$res = $this->admin->insertCategories($_POST,'category');
				if($res){
					$this->session->set_flashdata('message',$this->lang->line("category_added"));
				}else{
					$this->session->set_flashdata('emessage',$this->lang->line("error_category_added"));
				}
			//}
		}
		redirect(base_url("admin/add-category"));
	}

	public function addSubCategory()
	{
		if(isset($_POST['addsubcategory']))
		{
			$res = $this->admin->insertSubcategories($_POST,'subcategory');
			if($res){
				$this->session->set_flashdata('message',$this->lang->line("subcategory_added"));
			}else{
				$this->session->set_flashdata('emessage',$this->lang->line("error_subcategory_added"));
			}
		}
		redirect(base_url("admin/add-category"));
	}

	public function editCategory()
	{
		if($_POST['type']=="category")
		{
			$res = $this->common->updateData($_POST['type'],array($_POST['type']=>$_POST['category']),array('c_id'=>$_POST['id']));
		}else{
			$res = $this->common->updateData($_POST['type'],array($_POST['type']=>$_POST['category']),array('sc_id'=>$_POST['id']));
		}
		if($res)
		{
			echo 1;
		}else{
			echo 0;
		}
	}

	public function deleteCategory()
	{
		if($this->admin->deleteCategory($_POST))
		{
			echo 1;
		}else{
			echo 0;
		}
	}

	public function deleteAdmin()
	{
		if($this->admin->deleteAdmin($_POST))
		{
			$this->common->updateData("user",array("admin_name"=>""),array("admin_name"=>$_POST['admin_name']));
			echo 1;
		}else{
			echo 0;
		}
	}

	public function checkCategory()
	{
		if($this->common->updateData('category',array('show'=>$_POST['val']),array('c_id'=>$_POST['id'])))
		{
			echo 1;
		}else{
			echo 0;
		}
	}

	public function getSubcategory()
	{
		$html = '';
		$data = $this->common->getData('subcategory',array('c_id'=>$_POST['val']));
		$html .= '<option value="" selected>Select Sub Category</option>';
		if(!empty($data))
		{
			foreach ($data as $key => $value) :
				$html .= '<option value="'.$value['sc_id'].'">'.$value['subcategory'].'</option>';
			endforeach;
		}else{
			$html .= '<option value=""></option>';
		}
		print_r($html);
	}

	public function editSubscription()
	{
		$userid = $_POST['userid'];unset($_POST['userid']);
		$data = $this->common->getsData("user",array("userid"=>$userid));
		if($data['activation_date']=="0000-00-00");
		{
			$_POST['activation_date'] = date("Y-m-d");
		}
		if($data['email_domain_status']==1){
			$_POST['email_domain_status']=0;
		}
		if($_POST['renewal_date']!="" && $_POST['expiry_date']!="")
		{
			$_POST['renewal_date'] = date("Y-m-d",strtotime($_POST['renewal_date']));
			$_POST['expiry_date'] = date("Y-m-d",strtotime($_POST['expiry_date']));
			$_POST['account_status'] = 1;
		}
		$this->common->updateData("user",$_POST,array("userid"=>$userid));
		if($this->db->affected_rows())
		{
			echo "1";
		}else{
			echo "0";
		}
	}

	public function addTender()
	{
		$res = $this->admin->addTender();
		if($res)
		{
			$this->session->set_flashdata("message",$this->lang->line("tender_add"));
			redirect(base_url("admin/all-tenders"));
		}else{
			$this->session->set_flashdata("emessage",$this->lang->line("error_tender_add"));
			redirect(base_url("admin/add-tenders"));
		}
		//echo "<pre>";print_r($_POST);print_r($_FILES);die;
	}

	public function updateTender()
	{
		$posting_id = $_POST['posting_id'];
		unset($_POST['posting_id']);
		$tenderdata = $this->common->getField("tenders_free",$_POST);
		$tenderdata['tender_start_date'] = date('Y-m-d H:i:s',strtotime($tenderdata['tender_start_date']));
		$tenderdata['doc_last'] = date('Y-m-d H:i:s',strtotime($tenderdata['doc_last']));
		$tenderdata['update_date'] = date('Y-m-d H:i:s',strtotime($tenderdata['update_date']));
		//echo "<pre>"; print_r($tenderdata);die;
		
		if(isset($_POST['tender_sector']) && $_POST['tender_sector']){
			$tenderdata['tender_sector'] = implode(',', $_POST['tender_sector']);
		}
		$this->common->updateData("tenders_free",$tenderdata,array("posting_id"=>$posting_id));
		if($this->db->affected_rows())
		{
			$this->session->set_flashdata("message",$this->lang->line("tender_update"));
			redirect(base_url("admin/all-tenders"));
		}else{
			$this->session->set_flashdata("emessage",$this->lang->line("error_tender_update"));
			redirect(base_url("admin/update-tenders/".$posting_id));
		}
	}

	public function deleteFreeTenders()
	{
		$this->common->deleteData("tenders_free",array("posting_id"=>$_POST['posting_id']));
		if($this->db->affected_rows())
		{
			echo 1;
		}else{
			echo 0;
		}
	}

	public function updateTenderStatus()
	{
		if($this->common->updateData('tenders_free',array('tstatus'=>$_POST['val']),array('posting_id'=>$_POST['posting_id'])))
		{
			echo 1;
		}else{
			echo 0;
		}
	}

	public function addUserProfile()
	{
		//echo "<pre>";
		$_POST['ip_address'] = $_SERVER['REMOTE_ADDR'];
		$_POST['sector'] = (isset($_POST['sector'])?implode(",",$_POST['sector']):"");
		$_POST['show_sector'] = (isset($_POST['show_sector'])?implode(",",$_POST['show_sector']):"");
		$_POST['omit_sector'] = (isset($_POST['omit_sector'])?implode(",",$_POST['omit_sector']):"");
		$_POST['region_name'] = (isset($_POST['region_name'])?implode(",",$_POST['region_name']):"");
		$_POST['show_country'] = (isset($_POST['show_country'])?implode(",",$_POST['show_country']):"");
		$_POST['omit_region_name'] = (isset($_POST['omit_region_name'])?implode(",",$_POST['omit_region_name']):"");
		//print_r($_POST);die;
		
		$redirect = base_url("admin/add-user-profile");

        $_POST['userid'] = strtotime(date("Y-m-d H:i:s"));

		$res = $this->login->userRegistrationValidation($_POST,$redirect);
        
        if($res){
        	$this->session->set_flashdata("message","User Registration Successfull!");
            redirect($redirect);
        }
	}

	public function updateUserProfile()
	{
		$return = 1;
		$this->session->set_userdata(array("is_static_menu"=>1));
		$userid = $_POST['userid'];
		$saved_cpv = $_POST['saved_cpv'];
		unset($_POST['userid'],$_POST['saved_cpv']);
		$_POST['show_sector'] = (isset($_POST['show_sector'])?implode(",",$_POST['show_sector']):"");
        $_POST['show_country'] = (isset($_POST['show_country'])?implode(",",$_POST['show_country']):"");
        $_POST['extra_email'] = (isset($_POST['extra_email'])?implode(",",$_POST['extra_email']):"");
        $_POST['sector'] = (isset($_POST['sector'])?implode(",",$_POST['sector']):"");
        $_POST['product_services'] = (isset($_POST['product_services'])?implode(",",$_POST['product_services']):"");
        $_POST['omit_product_services'] = (isset($_POST['omit_product_services'])?implode(",",$_POST['omit_product_services']):"");
        $_POST['omit_sector'] = (isset($_POST['omit_sector'])?implode(",",$_POST['omit_sector']):"");
        $_POST['region_name'] = (isset($_POST['region_name'])?implode(",",$_POST['region_name']):"");
        $_POST['omit_region_name'] = (isset($_POST['omit_region_name'])?implode(",",$_POST['omit_region_name']):"");
        $_POST['sector_check'] = ((isset($_POST['sector_check']) && $_POST['sector_check']=="on")?1:0);
	    $_POST['varify'] = ((isset($_POST['varify']) && $_POST['varify']=="on")?1:0);
		$res = 0;
        if($this->admintype=="parent"){
        	$_POST['keywords'] = (isset($_POST['keywords'])?implode(",",$_POST['keywords']):"");
	        //$_POST['email_domain_status'] = ((isset($_POST['email_domain_status']) && $_POST['email_domain_status']=="on")?1:0);
	        $_POST['views'] = ((isset($_POST['views']) && $_POST['views']=="on")?1:0);
	        $_POST['authorization'] = ((isset($_POST['authorization']) && $_POST['authorization']=="on")?1:0);
	        $_POST['access_tender_type'] = ((isset($_POST['access_tender_type']))?$_POST['access_tender_type']:0);
	        $_POST['download_excel_status'] = ((isset($_POST['download_excel_status']) && $_POST['download_excel_status']=="on")?1:0);
			$_POST['cant_check_live_detail'] = ((isset($_POST['cant_check_live_detail']) && $_POST['cant_check_live_detail']=="on")?1:0);
			$_POST['cant_check_archive_detail'] = ((isset($_POST['cant_check_archive_detail']) && $_POST['cant_check_archive_detail']=="on")?1:0);
        	
        	$payment_status = ((isset($_POST['payment_status']) && $_POST['payment_status']=="on")?'paid':'free');
        	if($this->common->getsData("email_alert",array("userid"=>$userid))){
        		$this->common->updateData("email_alert",array("payment_status"=>$payment_status),array("userid"=>$userid));
        	}
        	//if(isset($_POST['show_demo_status'])) {
        		$show_demo_status = (isset($_POST['show_demo_status']) && $_POST['show_demo_status'] == "on")?1:0;
        		if($this->common->getsData("users_info",array("userid"=>$userid))) {
        			$this->common->updateData("users_info",array("show_demo_status"=>$show_demo_status),array("userid"=>$userid));
        		}else{
        			if($show_demo_status == 1) {
        				$this->common->insertData("users_info",array("show_demo_status"=>$show_demo_status,"userid"=>$userid));
        			}
        		}
        	//}
			if($this->common->getsData("users_other_info",array("userid"=>$userid))){
				$users_other_info = array(
										"download_excel_limit"=>$_POST['download_excel_limit'],
										"download_excel_status"=>$_POST['download_excel_status'],
										"set_limit_date"=>date("Y-m-d H:i:s"),
										"cant_check_live_detail"=>$_POST['cant_check_live_detail'],
										"cant_check_archive_detail"=>$_POST['cant_check_archive_detail']
									);
				$this->common->updateData("users_other_info",$users_other_info,array("userid"=>$userid));
			}else{
				if($_POST['download_excel_limit']!="" || $_POST['download_excel_status']!="" || $_POST['cant_check_live_detail']!="" || $_POST['cant_check_archive_detail']!=""){
					$users_other_info = array(
											"userid"=>$userid,
											"download_excel_limit"=>$_POST['download_excel_limit'],
											"download_excel_status"=>$_POST['download_excel_status'],
											"set_limit_date"=>date("Y-m-d H:i:s"),
											"cant_check_live_detail"=>$_POST['cant_check_live_detail'],
											"cant_check_archive_detail"=>$_POST['cant_check_archive_detail']
										);
					$this->common->insertData("users_other_info",$users_other_info);
				}
			}
			$res = 1;
	    }
		$userdata = $this->common->getField($this->search_table,$_POST);
		//print_r($userdata);die;
		$this->common->updateData($this->search_table,$userdata,array("userid"=>$userid));
		if($this->db->affected_rows()){
			$res = 1;
		}
		$this->dashboard->updateuserKeyword($userid,array("saved_cpv"=>$saved_cpv));
		if($this->db->affected_rows()){
			$res = 1;
		}
		if($res){
			//$admin_type = $this->session->userdata('admin_type');
			$this->session->set_flashdata("message","Profile Updated Successfully");
			redirect(base_url("admin/edit-user-profile/".$userid));
		}else{
			$this->session->set_flashdata("emessage","Profile Not Updated");
			redirect(base_url("admin/edit-user-profile/".$userid));
		}
	}

	public function addRemoveUsersFromGroup()
	{
		$val = ($_POST['val'] != "null" && $_POST['val']!="")?explode(",", $_POST['val']):array();
		$old_val = ($_POST['old_val']!="null" && $_POST['old_val']!="")?explode(",", $_POST['old_val']):array();
		if(count($val) > count($old_val)) {
			$id = array_diff($val, $old_val);
			if($id) {
				$id = implode(",", $id);
			}
			$data = $this->common->getsData("mail_group",array("mailid"=>$id));
			$ids = ($data['emailIds']!="")?explode(",", $data['emailIds']):array();
			if(! in_array($_POST['email'], $ids)) {
				array_push($ids,$_POST['email']);
				$this->common->updateData("mail_group",array("emailIds"=>implode(",", $ids)),array("mailid"=>$id));
				if($this->db->affected_rows()) {
					echo 1;
				}else{
					echo 0;
				}
			}
		}else{
			$id = array_diff($old_val, $val);
			if($id) {
				$id = implode(",", $id);
			}
			$data = $this->common->getsData("mail_group",array("mailid"=>$id));
			$ids = explode(",", $data['emailIds']);
			if(false !== $key = array_search($_POST['email'], $ids)) {
				unset($ids[$key]);
				$this->common->updateData("mail_group",array("emailIds"=>implode(",", $ids)),array("mailid"=>$id));
				if($this->db->affected_rows()) {
					echo 1;
				}else{
					echo 0;
				}
			}
		}
	}

	public function deleteUserProfile()
	{
		$this->common->deletedata($this->search_table,array("userid"=>$_POST['userid']));
		if($this->db->affected_rows())
		{
			if($data = $this->common->getData("saved_cpv",array("userid"=>$_POST['userid'])))
			{
				$this->common->deletedata("saved_cpv",array("userid"=>$_POST['userid']));
			}
			if($data = $this->common->getData("saved_history_tenders",array("userid"=>$_POST['userid'])))
			{
				$this->common->deletedata("saved_history_tenders",array("userid"=>$_POST['userid']));
			}
			if($data = $this->common->getData("saved_search",array("userid"=>$_POST['userid'])))
			{
				$this->common->deletedata("saved_search",array("userid"=>$_POST['userid']));
			}
			if($data = $this->common->getData("saved_tenders",array("userid"=>$_POST['userid'])))
			{
				$this->common->deletedata("saved_tenders",array("userid"=>$_POST['userid']));
			}
			if($data = $this->common->getData("sent_tenders",array("userid"=>$_POST['userid'])))
			{
				$this->common->deletedata("sent_tenders",array("userid"=>$_POST['userid']));
			}
			if($data = $this->common->getData("st_log",array("userid"=>$_POST['userid'])))
			{
				$this->common->deletedata("st_log",array("userid"=>$_POST['userid']));
			}
			echo 1;die;
		}
	}

	public function createAdmin()
	{
		//echo "<pre>";print_r($_POST);
		$sub_adminid = array();
		if(isset($_POST['sub_adminid']) && is_array($_POST['sub_adminid'])){
			$sub_adminid = $_POST['sub_adminid'];
			unset($_POST['sub_adminid']);
		}
		$admindata = $this->common->getField("admin",$_POST);
		$res = $this->common->insertData("admin",$admindata);
		if($res)
		{
			if($sub_adminid){
				foreach ($sub_adminid as $key => $value) {
					$this->common->updateData("admin",array("sub_adminid"=>$_POST['adminid']),array("adminid"=>$value));
				}
			}
			$this->session->set_flashdata("message",$this->lang->line("admin_add"));
			redirect(base_url("admin/admin-list"));
		}else{
			$this->session->set_flashdata("emessage",$this->lang->line("error_admin_add"));
			redirect(base_url("admin/create-admin"));
		}
	}

	public function editAdmin()
	{
		$old = (isset($_POST['old'])?implode(",", json_decode($_POST['old'])):"");//print_r($old);echo "<pre>";
		$sub_adminid = (isset($_POST['sub_adminid'])?implode(",",$_POST['sub_adminid']):"");//print_r($sub_adminid); die;
		$adminid = $_POST['adminid'];
		unset($_POST['adminid'],$_POST['old'],$_POST['sub_adminid']);
		$admindata = $this->common->getField("admin",$_POST);
		$update = false;
		if($old!=""){
			if($old!=$sub_adminid){
				$this->db->query('update admin set sub_adminid="" where adminid in ('.$old.')');
				if($this->db->affected_rows()) {
					$update = true;
				}
			}
		}
		if($sub_adminid!=""){
			if($old!=$sub_adminid){
				$this->db->query('update admin set sub_adminid="'.$adminid.'" where adminid in ('.$sub_adminid.')');
				if($this->db->affected_rows()) {
					$update = true;
				}
			}
		}
		$this->common->updateData("admin",$admindata,array("adminid"=>$adminid));

		if($this->db->affected_rows())
		{
			$update = true;
		}
		if($update){
			$this->session->set_flashdata("message",$this->lang->line("admin_edit"));
			redirect(base_url("admin/admin-list"));
		}else{
			$this->session->set_flashdata("emessage",$this->lang->line("error_admin_edit"));
			redirect(base_url("admin/edit-admin/".$adminid));
		}
	}

	public function uploadCountryCoverImage($value='')
	{
		$res = 0;
		$file_path='';
		//print_r($_POST);
		//print_r($_FILES);
		$ext = pathinfo($_FILES['cover_image']['name'], PATHINFO_EXTENSION);
		$name = strtolower(str_replace(" ", "-", $_POST['country_name']))."-image";
		$file_name = $name.".".$ext;
		//echo $file_name;
		//$imagedetails = getimagesize($_FILES['cover_image']['tmp_name']);
		if(!file_exists($file_path)){
			$file_path="assets/gt-cover/".$file_name;
			move_uploaded_file ($_FILES['cover_image']['tmp_name'],$file_path);
			$res = 1;
			$this->common->updateData("country",array("country_cover"=>$file_path),array("c_id"=>$_POST['country_id']));
		}
		$array = array("result"=>$res,"path"=>$file_path);
		header('Content-type: application/json; charset=utf-8"');
		echo json_encode($array);
	}

	public function advanceUserSearch()
	{
		$user=array();
		$_POST['date'] = $this->admin->checkDate($_POST['date']);
		//print_r($_POST);die;
		$data = $this->admin->advanceUserSearch($_POST);
		$query = $this->db->last_query();
		foreach ($data as $key => $value) {
			$user[] = array($value['u_id'],$value['userid'],$value['first_name'],$value['username'],$value['password_old'],$value['email'],$value['phone'],$value['country'],$value['reg_date']);
		}
		header('Content-type: application/json; charset=utf-8"');
        print_r(json_encode(array("data"=>$user,"query"=>$query)));
	}

    public function saveUsersAsExcel()
    {
        $this->load->dbutil();
        $this->load->helper('file');
        $this->load->helper('download');
        $delimiter = ",";
        $newline = "\r\n";
        $filename = "user.csv";
        $result = $this->db->get("user");
        //echo "<pre>"; print_r($result);die;
        $data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
        force_download($filename, $data);
        redirect(base_url("admin"));
    }

    public function addGenericDomain()
    {
    	if(isset($_POST['mail_domain']) && $_POST['mail_domain']){
    		foreach ($_POST['mail_domain'] as $key => $value) {
    			$this->common->insertData("mail_domain",array("mail_domain"=>$value,"type"=>"generic"));
    		}
    	}
    	redirect(base_url("admin/mail-domain-list"));
    }

    public function uploadCSVFile()
    {
    	$files =array();
    	if(isset($_FILES['other_users']) && $_FILES['other_users']){
    		$files = $_FILES;
    		//echo "<pre>";print_r($_FILES);
    		unset($_FILES['other_users']);
    	}
    	$fields = $this->db->list_fields("other_users");
    	unset($fields[58],$fields[59],$fields[60],$fields[61],$fields[62],$fields[63],$fields[64],$fields[65],$fields[66]);
    	//print_r($fields);die;
    	$file_name=$path='';
    	if(isset($files['other_users'])){
			$csv = $files['other_users'];
			$file_path = "assets/csv_files/";
			$ext = pathinfo($csv['name'], PATHINFO_EXTENSION);
			$name = "other_users";
			$file_name = $name.".".$ext;
			$path = $file_path.$file_name;
			echo "<pre>";
			if($ext=="csv"){
				if(file_exists($path)){
					unlink($path);
				}
				if(!file_exists($path)){
					if(move_uploaded_file($csv['tmp_name'],$path)){
						$csv_file = $path;
						$duplicate = array();$count=$row=0;
						if(file_exists($path)){
							if (($handle = fopen($csv_file, "r")) !== FALSE) {
						   		fgetcsv($handle);
						   		while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
						        	$num = count($data);
						        	$row++;
							        for ($c=0; $c < $num; $c++) {
							          	$col[$c] = $data[$c];
							        }
							        // print_r($fields);
							        // print_r($col);
							        $user = array_combine($fields, $col);
							        if(!$this->common->getsData("user",array("email"=>$user['email']))){
							        	if(!$this->common->getsData("other_users",array("email"=>$user['email']))){
								        	$user['u_id'] = "";
								        	$user['userid'] = strtotime(date("Y-m-d H:i:s"))+$row;
								        	$exp = end(explode("@",$value['email']));
											if($this->common->getsData("mail_domain",array("mail_domain"=>trim($exp)))){
												$user['email_domain']="generic";
											}else{
												$user['email_domain']="corporate";
											}
								        	//print_r($user);
								        	$this->common->insertData("other_users",$user);
								        }
							        }else{
							        	$count++;
							        	array_push($duplicate, array("email"=>$user['email'],"first_name"=>$user['first_name'],"last_name"=>$user['last_name']));
							        }
							    }
							    fclose($handle);
								if(file_exists($csv_file)){
									unlink($csv_file);
								}
							}
						}
					}
				}
			}
		}die;
		if($duplicate){
			$data['duplicate'] = $duplicate;
			$data['count'] = $count;
			$this->loadAdminHtml("already-registered-users","Already Registered Users",$data);
		}else{
			$this->session->set_flashdata("message","Other Users Uploaded Successfully!");
			redirect(base_url("admin"));
		}
    }

    public function writeNotes()
    {
    	$status = $_POST['status'];unset($_POST['status']);
    	$nid = "";
    	if($_POST['nid']==""){
    		unset($_POST['nid']);
    	}else{
    		$nid = $_POST['nid'];
    	}
    	if(isset($status) && $status=="add"){
	    	$_POST['createdid'] = $_POST['updatedid'];
	    	$_POST['created_date'] = $_POST['updated_date'];
	    	$this->common->insertData("notes",$_POST);
	    	$this->session->set_flashdata("message","Note Added Successfully!");
    	}else{
	    	$this->session->set_flashdata("message","Note Updated Successfully!");
	    	$this->common->updateData("notes",$_POST,array("nid"=>$nid));
	    	/*if($this->db->affected_rows()){
	    		echo 1;
	    	}else{
	    		echo 0;
	    	}die;*/
    	}
	    redirect(base_url("admin/write-notes"));
    }

    public function haveYouAnyProblem()
    {
    	$res = 0;
    	if($_POST){
    		if(isset($_FILES['error_image']) && $_FILES['error_image']){
    			$file_path = "assets/admin/issue_images/".date("Y-m-d");
	            if(!is_dir($file_path))
	            {
	                mkdir($file_path,0777,true);
	            }
    			$ext = pathinfo($_FILES['error_image']['name'], PATHINFO_EXTENSION);
                $name = strtotime(date('Y-m-d H:i:s'));
                $file_name = $name.".".$ext;
                $path = $file_path."/".$file_name;
    			if(move_uploaded_file($_FILES['error_image']['tmp_name'],$file_path."/".$file_name)){
                    $_POST['error_image'] = $file_path."/".$file_name;
                }
    		}
    		$_POST['date'] = date("Y-m-d");
    		$_POST['admnid'] = $this->adminid;
    		$_POST['status'] = 1;
    		$res = $this->common->insertData("error_request",$_POST);
    	}
    	if($res){
    		$this->session->set_flashdata("message","Your Issue Request Submitted Successfully.");
    	}else{
    		$this->session->set_flashdata("emessage","Your Issue Request Submitted Successfully.");
    	}
    	redirect(base_url("admin"),'refresh');
    }
}