<?php
class MY_Controller extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		ini_set('memory_limit', "20480M");
		ini_set('date.timezone', date_default_timezone_get());
		
		$this->load->helper("text");
		$this->load->model('common_model','common');
		$this->config->load('custom');
		$this->lang->load('user');
		$this->load->library('email');
		//$this->load->library('cart');
		$this->load->helper("user");
		$this->load->helper("form");
		$this->load->helper("user_registration");

		$this->userid = (isset($_COOKIE["userid"]))?$_COOKIE["userid"]:"";//$this->session->userdata("userid");
		if(isset($this->userid) && $this->userid!="") {
			$this->is_user_logged_in = (isset($_COOKIE["is_user_logged_in"]))?$_COOKIE["is_user_logged_in"]:0;//$this->session->userdata('is_user_logged_in');
			$this->userinfo = $this->getUserRegistration(array("U.userid"=>$this->userid));
			$this->subscription = $this->common->subscriptionStatus();
			$this->subtime = $this->common->subscriptionTime();
			$this->lsstatus = $this->common->getUserLoginSubscriptionStatus();
		}
		
		$segment = $this->uri->segment(2);
		$seg_array = array("email-usersearch","usersearch","tendersearch");
		/* Protact User to come back after logout code START */
		$this->output->set_header('Last-Modified:'.gmdate('D, d M Y H:i:s').'GMT');
		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate');
		if(!in_array($segment, $seg_array)){
			$this->output->set_header('Cache-Control: post-check=0, pre-check=0',false);
		}else{
			$this->output->set_header('Cache-Control: post-check=0, pre-check=0');
		}
		$this->output->set_header('Pragma: no-cache');
		/* Protact User to come back after logout code END */

		//$this->menu = $this->common->getMenus();
		/* The code save the las activity of users whether its free or paid both code START */
		if($this->userid!=""){
			// if($this->common->getsData("online_user",array("userid"=>$this->userid))){
			if(isset($this->userinfo) && $this->userinfo) {
				$this->common->updateData("online_user",array("last_activity_time"=>date("Y-m-d H:i:s")),array("userid"=>$this->userid));
			}else{
				$this->common->insertData("online_user",array("last_activity_time"=>date("Y-m-d H:i:s"),"userid"=>$this->userid));
			}
		}
		//if($this->subscription == 1 && $this->subtime == 1){}
		/* The code save the las activity of users whether its free or paid both code END */
	}

	public function subscriptionStatus()
	{
		return $this->common->returnUserid();
	}

	public function subscriptionTime()
	{
		return $this->common->subscriptionTime();
	}

	public function loadHtml($pagename='',$title='',$data=array(),$leftbar='',$rightbar='',$header='',$footer='')
	{
		$data['head_title'] = $title;
		$is_logged_in = (isset($_COOKIE["is_user_logged_in"]))?$_COOKIE["is_user_logged_in"]:0;//$this->session->userdata('is_logged_in');
		if($header){
			$header1 = $header;
		}else{
			$header1 = 'gt_header';
		}
		$this->load->view($header1,$data);
		if($leftbar){
			$this->load->view($leftbar,$data);
		}
		$this->load->view($pagename,$data);
		if($rightbar){
			$this->load->view($rightbar,$data);
		}
		if($footer){
			$footer1 = $footer;
		}else{
			$footer1 = 'gt_footer';
		}
		$this->load->view($footer1,$data);
		//$this->load->view('gt_footer');
	}

	public function loadDashboard($pagename='',$title='',$data=array())
	{
		$data['head_title'] = $title;
		$is_logged_in = (isset($_COOKIE["is_user_logged_in"]))?$_COOKIE["is_user_logged_in"]:0;//$this->session->userdata('is_logged_in');
		$this->load->view("gt_dashboard_header",$data);
		$this->load->view("gt_dashboard_leftbar",$data);
		$this->load->view($pagename,$data);
		$this->load->view("gt_dashboard_footer",$data);
	}

	public function fullPageHtml($pagename='',$title='',$data=array())
	{
		$data['title'] = $title;
		$this->load->view($pagename,$data);
	}

	public function loadAdminHtml($pagename='',$title='',$data=array())
	{
		$data['title'] = $title;
		$is_admin_logged_in = $this->session->userdata('is_admin_logged_in');
		if(!isset($is_admin_logged_in) || $is_admin_logged_in != true)
		{
			$header = 'admin_header';
		}else{
			$header = 'admin_header';
		}
		$this->load->view($header,$data);
		if(!isset($is_admin_logged_in) || $is_admin_logged_in != true)
		{
		}else{
			$sidebar = 'admin_sidebar';
			$this->load->view($sidebar,$data);
		}
		$this->load->view($pagename,$data);
		$this->load->view('admin_footer');
	}

	public function loadTrackerHtml($pagename='',$title='',$data=array())
	{
		$data['title'] = $title;
		$this->load->view("admin_header",$data);
		$this->load->view("admin_sidebar",$data);
		$this->load->view($pagename,$data);
		$this->load->view('admin_footer');
	}

	public function getUserRegistration($where=array())
	{
		$this->db->select("U.*,EA.frequency,EA.frequency_limit");//,C.*,P.*
		$this->db->from("user as U");
		// $this->db->join("country as C","U.country=C.country_code","left");
		// $this->db->join("package as P","U.package=P.p_id","left");
		$this->db->join("email_alert as EA","U.userid=EA.userid","left");
		if($where){
			$this->db->where($where);
		}
		$res = $this->db->get()->result_array();
		return $res;
	}
	public function searchCPV()
	{
		$html='';
		$term = $_GET['term'];
		$check = $_GET['check'];
        $data = $this->autocomplete($term);
        $cpv = $this->common->getsData("saved_cpv",array("userid"=>$this->userid),array("saved_cpv"));
        $html = getCPVDropDowns($data,$cpv,$check);
        header('Content-type: application/json; charset=utf-8"');
        print_r(json_encode(array("html"=>$html,"query"=>$this->db->last_query())));
	}
	public function searchCPVLink()
	{
		$html='';
		$term = $_GET['term'];
        $data = $this->autocomplete($term);
        $cpv = $this->common->getsData("saved_cpv",array("userid"=>$this->userid),array("saved_cpv"));
        $html = getCPVDropDownsLinks($data,$cpv);
        header('Content-type: application/json; charset=utf-8"');
        print_r(json_encode(array("html"=>$html)));
	}
	public function autocomplete($term)
    {
    	if($term!="")
    	{
	        $query = $this->db->query("SELECT *
	            FROM cpv C
	            WHERE C.cpv_description LIKE '%".$term."%' OR C.cpv_code LIKE '%".$term."%'
	            GROUP BY C.cpv_code");
	        return $query->result_array();
    	}
    }

    public function getOnlineUsers()
    {
    	$min5bef = date("Y-m-d H:i:s",strtotime("-5 minutes"));
    	$now = date("Y-m-d H:i:s");
    	//echo $now." ".$min5bef;
    	$query = 'select U.first_name,U.last_name,U.userid from online_user as OLU 
    		left join user as U on OLU.userid = U.userid where OLU.last_activity_time BETWEEN "'.$min5bef.'" and "'.$now.'"';
    	if($this->admintype != "parent"){
            $query .= ' AND admin_name = "'.$this->adminname.'"';
        }
    	$result = $this->db->query($query)->result_array();
    	//print_r($result);die;
    	$html = onlineUsersList($result);
    	echo $this->common->jsonEncode(array("online_users"=>$html));die;
    }
} 