<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');

if (!function_exists('dateSort'))
{
    function dateSort($a, $b) {
        return strtotime($a) - strtotime($b);
    }
}

if (!function_exists('getUserNameForAdmin'))
{
    function getUserNameForAdmin($userid = '')
    {
        $CI =& get_instance();
        $user = $CI->common->getsData("user",array("userid"=>$userid));
        if($user) {
            return $user['first_name']." ".$user['last_name'];
        }
    }
}

if (!function_exists('modal'))
{
    function modal($id='',$title='')
    {
        $html='
            <div class="modal fade" id="'.$id.'" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <h4 class="modal-title">'.$title.'</h4>
                        </div>
                        <div class="modal-body">
                            
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary">Save</button>
                        </div>
                    </div>
                </div>
            </div>
        ';
        return $html;
    }
}

if (!function_exists('onlineUsersList'))
{
    function onlineUsersList($users=array())
    {
        $html = '';
        if($users){ foreach ($users as $key => $value) :
            $html .= '<li><a href="javascript:void(0)" class="register_popup" data-user="'.htmlentities(json_encode($value), ENT_QUOTES, 'UTF-8').'">'.$value['first_name'].' '.$value['last_name'].'<span class="pull-right badge bg-blue">30</span></a></li>';//base_url("admin/edit-user-profile/".$value['userid'])
        endforeach; }else{
            $html .= '<li><a href="#">No User is online.<span class="pull-right badge bg-blue"></span></a></li>';
        }
        return preg_replace( "/\r|\n/", "",$html);
    }
}

if (!function_exists('reminderNotesNotification'))
{
    function reminderNotesNotification()
    {
        $CI =& get_instance();
        $reminder_notes = $CI->admin->getNotes();
        $countryarray = $CI->config->item("countryarray");
        $html = '<div class="box box-primary direct-chat direct-chat-success">
                    <div class="box-header">
                        <i class="ion ion-clipboard"></i>
                        <h3 class="box-title reminder_count">You have '.count($reminder_notes).' Reminders.</h3>
                        <div class="pull-right box-tools">
                            <button class="btn btn-warning btn-sm" data-toggle="tooltip" title="Advance Search" data-widget="chat-pane-toggle"><i class="fa fa-calendar"></i></button>
                            <button class="btn btn-primary btn-sm pull-right" data-widget="collapse" data-toggle="tooltip" title="Collapse" style="margin-right: 5px;"><i class="fa fa-minus"></i></button>
                        </div>
                    </div>
                    <div class="box-body" style="height: 272px;overflow-x:hidden;overflow-y:scroll;">
                        <div class="direct-chat-messages">
                            <ul class="todo-list">';
                        $html.=reminderNotes($reminder_notes,date("d-m-Y"));
                    $html.='</ul>
                        </div>
                        <div class="direct-chat-contacts">
                            <div class="row" style="margin-right:0px;">
                                <div class="col-md-12">
                                    <div class="col-md-6">
                                        <form class="notes_search_form" method="post" >
                                            <div id="notes_search_fields">
                                                <div class="form-group">
                                                    <label>Search By Date</label>
                                                    <div>
                                                        <input type="text" name="picked_date" id="picked_date" class="form-control" value="" placeholder="EX -> YYYY-MM-DD">
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <label>Search By Email</label>
                                                    <div>
                                                        <input type="text" name="email" class="form-control" value="">
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <label>Search By Country</label>
                                                    <div>
                                                        <select name="country" class="form-control">
                                                            <option value="">Select Country</option>';
                                                    if($countryarray){
                                                        foreach ($countryarray as $key => $value) {
                                                            $html.='<option value="'.$value.'">'.$value.'</option>';
                                                        }
                                                    }
                                                $html.='</select>
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <div>
                                                        <input type="submit" class="btn btn-warning btn-block" value="Search">
                                                    </div>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                    <div class="col-md-6">
                                        <div id="calendar"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>';
        return $html;
    }
}

if (!function_exists('reminderNotes'))
{
    function reminderNotes($reminder_notes = array(),$today='')
    {
        $html = '';
        if($reminder_notes){
            foreach ($reminder_notes as $key => $value) ://'.(($value['reminder_status']==1)?'style="background-color:#61A514"':"").'
        $html.='<li class="reminder_status_'.$value['unid'].'">
                    <input type="checkbox" class="reminder_status" data-id="'.$value['unid'].'" data-rd="'.strtotime($value['reminder_date']).'" data-now="'.strtotime(date("Y-m-d H:i:s")).'" data-table="user_notes" '.(($value['reminder_status']==1)?'checked="checked"':"").' data-set="reminder_status" data-wh="[{'."unid".":".$value['unid'].'}]">
                    <span class="text"><b>'.ucwords($value['admin_name']).'</b> set a reminder for <b><a href="'.base_url("admin/edit-user-profile/".$value['userid']).'" data-id="'.$value['userid'].'" class="userid" style="color:#000;" target="_blank">'.(($value['first_name']!="")?ucwords($value['first_name'].' '.$value['last_name']):$value['userid']).'</a></b></span>';
                    $color = "";
                    if($value['reminder_status']==1){
                        $color = "success";
                    }else{
                        if(strtotime($value['reminder_date']) > strtotime(date("Y-m-d H:i:s"))){
                            $color = "warning";
                        }else{
                            $color = "danger";
                        }
                    }
            $html.='<small class="label label-'.$color.'" data-color="'.$color.'"><i class="fa fa-clock-o"></i> '.date("d-m-Y h:i A",strtotime($value['reminder_date'])).'</small><br>
                    <span title="'.$value['note'].'">'.word_limiter($value['note'],5).'</span>
                </li>';
          endforeach;
        }else{
            $html.='<li>No Reminder '.(($today!="")?"for ".$today:"According your search.").'...</li>';
        }
        return $html;
    }
}

if (!function_exists('haveYouAnyProblem'))
{
    function haveYouAnyProblem()
    {
        $html = '<a href="#" class="dropdown-toggle" data-toggle="dropdown">
                  <span class="hidden-xs">Have you any Problem?</span>
                </a>
                <ul class="dropdown-menu">
                  <div class="box box-primary">
                    <div class="box-header with-border">
                      <h3 class="box-title">Submit Issue you have.</h3>
                      <span><a href="'.base_url("admin/error-request").'" class="btn btn-warning btn-xs">All Errors</a></span>
                    </div>
                    <form method="post" action="'.base_url("admin/haveYouAnyProblem").'" enctype="multipart/form-data">
                      <div class="box-body">
                        <div class="form-group">
                          <label for="exampleInputEmail1">Issue Description</label>
                          <textarea class="form-control" name="error_notes" rows="6" placeholder="Enter Your Query"></textarea>
                        </div>
                        <div class="form-group">
                          <label for="exampleInputFile">Screenshot of error</label>
                          <input type="file" name="error_image">
                        </div>
                      </div>
                      <div class="box-footer">
                        <button type="submit" class="btn btn-primary btn-block">Submit</button>
                      </div>
                    </form>
                  </div>
                </ul>';
        return $html;
    }
}

if(!function_exists('subscribeUser'))
{
    function subscribeUser($userInfo=array())
    {
        $html='';
        if($userInfo['account_status']=="1")
        {
            $html='
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label>Start Date 1</label>
                            <div class="input-group date datetimepicker">
                                '.date("Y-m-d H:i A",strtotime($userInfo["renewal_date"])).'
                            </div>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label>End Date</label>
                            <div class="input-group date datetimepicker">
                                '.date("Y-m-d H:i A",strtotime($userInfo["expiry_date"])).'
                            </div>
                        </div>
                    </div>
                </div>';
        }else{
            $html='<div class="modal-body">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>Start Date 0</label>
                                    <div class="input-group date datetimepicker">
                                        <input type="text" name="renewal_date" id="renewal_date" class="form-control date" />
                                        <span class="input-group-addon">
                                            <span class="glyphicon glyphicon-calendar"></span>
                                        </span>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>End Date</label>
                                    <div class="input-group date datetimepicker">
                                        <input type="text" name="expiry_date" id="expiry_date" class="form-control date" />
                                        <span class="input-group-addon">
                                            <span class="glyphicon glyphicon-calendar"></span>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>';
        }
        return $html;
    }
}

if(!function_exists('editSubscription'))
{
    function editSubscription($userInfo=array())
    {
        $html='';
        $html='
                <div class="modal-body">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>Start Date</label>
                                <div><p>'.date("Y-m-d H:i:s A",strtotime($userInfo["renewal_date"])).'</p></div>
                                <div class="input-group date datetimepicker">
                                    <input type="text" name="renewal_date" id="renewal_date" class="form-control date" value="" />
                                    <span class="input-group-addon">
                                        <span class="glyphicon glyphicon-calendar"></span>
                                    </span>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>End Date</label>
                                <div><p>'.date("Y-m-d H:i:s A",strtotime($userInfo["expiry_date"])).'</p></div>
                                <div class="input-group date datetimepicker">
                                    <input type="text" name="expiry_date" id="expiry_date" class="form-control date" />
                                    <span class="input-group-addon">
                                        <span class="glyphicon glyphicon-calendar"></span>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>';
            return $html;
    }
}

if(!function_exists('editAlertDates'))
{
    function editAlertDates($userInfo=array())
    {
        $html='';
        $html='
                <div class="modal-body">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <input type="hidden" name="userid" id="userid_popup" value="'.$userInfo["userid"].'">
                                <label>Start Date</label>
                                <div><p>'.(($userInfo["alert_start"]!="0000-00-00 00:00:00")?date("Y-m-d H:i:s A",strtotime($userInfo["alert_start"])):"").'</p></div>
                                <div class="input-group date datetimepicker" style="color:black;">
                                    <input type="text" name="alert_start" id="alert_start_popup" class="form-control date" value="" />
                                    <span class="input-group-addon">
                                        <span class="glyphicon glyphicon-calendar"></span>
                                    </span>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>End Date</label>
                                <div><p>'.(($userInfo["alert_end"]!="0000-00-00 00:00:00")?date("Y-m-d H:i:s A",strtotime($userInfo["alert_end"])):"").'</p></div>
                                <div class="input-group date datetimepicker" style="color:black;">
                                    <input type="text" name="alert_end" id="alert_end_popup" class="form-control date" />
                                    <span class="input-group-addon">
                                        <span class="glyphicon glyphicon-calendar"></span>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>';
            return $html;
    }
}

if(!function_exists('addGenericDomainForm'))
{
    function addGenericDomainForm()
    {
        $html='';
        $html='<form method="post" action="'.base_url("admin/addGenericDomain").'" id="editAlertDateForm">
                    <div class="modal-body">
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label class="col-md-4">Domain Name</label>
                                    <div class="input-group col-md-8">
                                        <select name="mail_domain[]" style="width:100%" class="form-control select2" multiple>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </div>
                </form>';
        return $html;
    }
}


if(!function_exists('userNotesModel'))
{
    function userNotesModel($notes_array = array())
    {
        $notes = $notes_array['notes'];
        $userid = $notes_array['userid'];
        $action = $notes_array['action'];
        $html='';
        $html='<form method="post" action="'.base_url("user_search/addUserNotes").'" id="addUserNoteFormPopup">
                    <div class="modal-body">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="col-md-6">Set Reminder Date</label>
                                    <div class="input-group date datetimepicker col-md-6" style="color:black;">
                                        <input type="text" name="reminder_date" class="form-control date" value="'.(isset($notes[0]['reminder_date'])?$notes[0]['reminder_date']:"").'" />
                                        <span class="input-group-addon">
                                            <span class="glyphicon glyphicon-calendar"></span>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <input type="hidden" name="status" value="1" >
                                    <input type="hidden" name="userid" value="'.(isset($userid)?$userid:"").'" >
                                    <input type="hidden" name="action" value="'.(isset($action)?$action:"").'" >
                                </div>';
                                if($action=="edit"){
                                    $html.='<input type="hidden" name="unid" value="'.(isset($notes[0]['unid'])?$notes[0]['unid']:"").'" >';
                                }
                                if($action!="edit"){
                        $html.='<div class="form-group">
                                    <label class="col-md-12">Write a note for user.</label>
                                    <div class="input-group col-md-12">';
                                    $html.='<textarea class="form-control" rows="10" name="note">'.(isset($notes[0]['note'])?$notes[0]['note']:"").'</textarea>
                                    </div>
                                </div>';
                            }
                    $html.='</div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </div>
                </from>
                <script>
                    $(".datetimepicker").datetimepicker({
                        format: "YYYY-MM-DD HH:mm"
                    });
                </script>';
        return $html;
    }
}

if(!function_exists('getOnlineUsersHTML'))
{
    function getOnlineUsersHTML()
    {
        $CI =& get_instance();
        $min5bef = date("Y-m-d H:i:s",strtotime("-5 minutes"));
        $now = date("Y-m-d H:i:s");
        //echo $now." ".$min5bef;
        $query = 'SELECT U.first_name,U.last_name,U.userid from online_user as OLU 
            left join user as U on OLU.userid = U.userid 
            where OLU.last_activity_time BETWEEN "'.$min5bef.'" 
            AND "'.$now.'" ';
            if($CI->admintype != "parent"){
                $query .= ' AND admin_name = "'.$CI->adminname.'"';
            }
        $result = $CI->db->query($query)->result_array();
        //print_r($result);
        $html = onlineUsersList($result);
        return json_encode(array("online_users"=>preg_replace( "/\r|\n/", "",$html)));die;
    }
}
// ------------------------------------------------------------------------
/* End of file admin_helper.php */
/* Location: ./system/helpers/admin_helper.php */