<?php

if(!function_exists('formatSizeUnits')) {

    function formatSizeUnits($bytes) {
        if ($bytes >= 1073741824)
        {
            $bytes = number_format($bytes / 1073741824, 2) . ' GBs';
        }
        elseif ($bytes >= 1048576)
        {
            $bytes = number_format($bytes / 1048576, 2) . ' MBs';
        }
        elseif ($bytes >= 1024)
        {
            $bytes = number_format($bytes / 1024, 2) . ' KBs';
        }
        elseif ($bytes > 1)
        {
            $bytes = $bytes . ' bytes';
        }
        elseif ($bytes == 1)
        {
            $bytes = $bytes . ' byte';
        }
        else
        {
            $bytes = '0 bytes';
        }

        return $bytes;
    }
}

if(!function_exists('folderSize')) {
    function folderSize ($dir)
    {
        $size = 0;
        foreach (glob(rtrim($dir, '/').'/*', GLOB_NOSORT) as $each) {
            $size += is_file($each) ? filesize($each) : folderSize($each);
        }
        return formatSizeUnits($size);
    }
}

if(!function_exists('ip_details')) {
    function ip_details($IPaddress) 
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL,"http://ipinfo.io/{$IPaddress}");
        $CurlExecutionResult = curl_exec ($ch);
        return json_decode($CurlExecutionResult,TRUE);
        // $json       = file_get_contents("http://ipinfo.io/{$IPaddress}");
        // $details    = json_decode($json,TRUE);
        // return $details;
    }
}