<?php 
class Admin extends MY_Admin_Controller {
	Public function __construct() { 
		parent::__construct();
		$this->is_logged_in();
	}
	public function is_logged_in()
	{
		$is_admin_logged_in = $this->session->userdata('is_admin_logged_in');
		if(!isset($is_admin_logged_in) || $is_admin_logged_in != true) {

			redirect(base_url("admin-login"));
		}
	}

	public function index()
	{
		$data = array();
		if($this->admintype != "tcs") {
			if($this->admintype!="parent"){ // If admin or subadmin logged In
				$data['admin_users'] = $this->usearch->getRows(array("admin_name"=>$this->adminname),array(),1);
				$data['admin_verify_users'] = $this->usearch->getRows(array("admin_name"=>$this->adminname,"varify"=>"1"),array(),1);
				$data['admin_unverify_users'] = $this->usearch->getRows(array("admin_name"=>$this->adminname,"varify"=>"0"),array(),1);
			}
			if($this->admintype=="parent"){
				$data['this_week'] = $this->usearch->getRows(array("day_search"=>"thisweek"),array(),1);
				$data['this_month'] = $this->usearch->getRows(array("day_search"=>"thismonth"),array(),1);
				$data['reg_today'] = $this->usearch->getRows(array("reg_date"=>date("Y-m-d")),array(),1);
				$data['total_users'] = $this->usearch->getRows(array(),array(),1);
				$data['verify_users'] = $this->usearch->getRows(array("varify"=>"1"),array(),1);
				$data['unverify_users'] = $this->usearch->getRows(array("varify"=>"0"),array(),1);
				$data['tender_today'] = $this->search->getRows(array("date_c"=>date("Y-m-d")),'',array(),"tenders",1);
				$data['tender_live'] = $this->search->getRows(array("tender_type"=>"live"),'',array(),"tenders",1);
			}
			//$data['tender_archive'] = $this->search->getRows(array("tender_type"=>"archive"),'',array(),"tenders_archive",1);
			$data['country'] = $this->admin->getCountryJson();
			$this->loadAdminHtml("index","Home Page",$data);
		}else{
			$this->loadAdminHtml("tcs_index","Home Page",$data);
		}
	}

	public function checkSocketIO()
	{
		$this->load->view("socket-page");
	}

	public function addCategoryPage()
	{
		$data['category'] = $this->common->getData('category');
		$data['category_by'] = $this->common->getData('category_by');
		$this->loadAdminHtml("add-category","Add Category",$data);
	}

	public function allCategoryPage()
	{
		$data['allcategory'] = $this->admin->getAllCategory();
		$this->loadAdminHtml('all-category-list','All Category List',$data);
	}

	public function usersProfilesTenderSearch($userid='')
	{
		$data['tender_sector'] = $this->config->item("sector_industry");
        $data['country_region'] = $this->config->item("country_region");
        $data['notice_type_search'] = $this->config->item("notice_type_search");

        $data['saved_cpv'] = $this->common->getsData("saved_cpv",array("userid"=>$userid));
        $data['profile'] = $this->common->getsData("user",array("userid"=>$userid),array("userid","sector","omit_sector","product_services","omit_product_services","region_name","omit_region_name","notice_type"));
		$this->loadAdminHtml('user_search/user-advance-search-redirect','User Advance Search Redirect',$data);
	}

	public function usersRegistrationPage($limit='')
	{
		$get=array();
		if($limit)
		{
			$get['limit'] = $limit;
		}else{
			$get['limit'] = 0;
		}
		$data = $this->admin->getAllUserRegistration($get); //$this->getUserRegistration();
		//echo "<pre>"; print_r($data);die;
		$this->loadAdminHtml('registration-list','Registration List',$data);
	}

	public function userSubscriptionPopup()
	{
		$html='';
		$userInfo = $this->common->getsData("user",array("userid"=>$_POST['userid']),array("userid","renewal_date","expiry_date","account_status"));
		//echo $this->db->last_query();print_r($userInfo);die;
		$html=subscribeUser($userInfo);
		header('Content-type: application/json; charset=utf-8"');
		echo json_encode(array("html"=>$html,'status'=>$userInfo['account_status']));
	}

	public function editSubscriptionPopup()
	{
		$html='';
		$userInfo = $this->common->getsData("user",array("userid"=>$_POST['userid']),array("userid","renewal_date","expiry_date","account_status"));
		$html=editSubscription($userInfo);
		header('Content-type: application/json; charset=utf-8"');
		echo json_encode(array("html"=>$html,'status'=>$userInfo['account_status']));
	}

	public function addTenderPage()
	{
		$data = $this->common->getDropdowns(array("cpv","currency","funding_agency"));
		$data['notice_type'] = $this->config->item("notice_type");
		$data['bidding_type'] = $this->config->item("bidding_type");
		$data['country'] = $this->common->getData("country",'','',array("field"=>"country_name","by"=>"asc"));
		$data['tender_sector'] = $this->config->item("sector_industry");
		//$data['tender_sector'] = $this->common->getData("tender_sector",'','',array("field"=>"tender_sector_name","by"=>"asc"));
		$this->loadAdminHtml('add-tender','Add Tender',$data);
	}

	public function updateTenderPage($posting_id='')
	{
		$data = $this->common->getDropdowns(array("cpv","currency","funding_agency"));
		$data['notice_type'] = $this->config->item("notice_type");
		$data['bidding_type'] = $this->config->item("bidding_type");
		$data['country'] = $this->common->getData("country",'','',array("field"=>"country_name","by"=>"asc"));
		$data['tender'] = $this->common->getsData("tenders_free",array("posting_id"=>$posting_id));
		$data['tender_sector'] = $this->common->getData("tender_sector",'','',array("field"=>"tender_sector_name","by"=>"asc"));
		$this->loadAdminHtml('update-tender','Update Tender',$data);
	}

	public function allTenderPage()
	{
		$where = array();
		$type = $this->session->userdata("admin_type");
        if($type=="child"){
        	$where = array("adminid"=>$this->adminid);
        }
		$data['tender'] = $this->admin->getFreeTenderInfo($where); //$this->common->getData("tenders_free");
		$this->loadAdminHtml('all-tender','All Tender',$data);
	}

	public function userProfilePage($userid='')
	{
		$data['profile'] = $this->common->getsData("user",array("userid"=>$userid));
		//echo "<pre>"; print_r($this->session->all_userdata());die;
		$data['admin_type'] = $this->session->userdata('admin_type');
		$this->loadAdminHtml('user-profile','User Profile',$data);
	}

	public function userProfileEditPage($userid='')
	{
		//$data = $this->common->getDropDowns(array("country"));
		//$data['package'] = $this->config->item("package");
		$data['country'] = $this->config->item("countryarray");
		$data['tender_sector'] = $this->config->item("sector_industry");
		$data['profile'] = $this->admin->getUserDashboardSearchFields($userid); //$this->common->getsData("user",array("userid"=>$userid));
		$data['users_other_info'] = $this->common->getsData("users_other_info",array("userid"=>$userid),array("download_excel_limit","download_excel_status","cant_check_live_detail","cant_check_archive_detail"));
		$data['users_info'] = $this->common->getsData("users_info",array("userid"=>$userid));
		$data['email_alert'] = $this->common->getsData("email_alert",array("userid"=>$userid));
		//echo "<pre>";print_r($data['profile']);die;
		$data['user_title'] = $this->config->item("title");
		$data['hear'] = $this->config->item("hear");
		$data['admin_type'] = $this->session->userdata('admin_type');
		$data['country_region'] = $this->config->item("country_region");
        $data['notice_type_search'] = $this->config->item("notice_type_search");
        $users_query = $this->session->userdata("user_search_query");
        if($users_query != ""){
	        $query = str_replace("U.userid,U.title,U.first_name,U.last_name,U.email,U.account_status,U.renewal_date,U.expiry_date,U.country,U.organization,U.password,U.suspend,U.alert_start,U.alert_end,U.admin_name,U.email_alert,U.hear,U.sector,U.reg_date,U.city,U.state,U.address1,U.address2,U.designation,U.pincode,U.country_code,U.phone,U.mobile_no,U.fax,U.website_url,U.area_code,EA.frequency,EA.frequency_limit,U.varify", "U.userid", $users_query);
	        $users_userid = $this->db->query($query)->result_array();
	        $data['uid_array'] = array_column($users_userid, "userid");
	    }else{
	    	$data['uid_array'] = array();
	    }
		$this->loadAdminHtml('edit-user-profile','User Profile Edit',$data);
	}

	public function createAdminPage()
	{
		$data['admin'] = $this->admin->getSubAdminInfo(array("sub_adminid"=>"","admin_type !="=>"sub-parent"));
		$this->loadAdminHtml('create-admin','Create Admin',$data);
	}

	public function errorRequestPage()
	{
		$data['errors'] = $this->admin->getErrorRequest(); 
		$this->loadAdminHtml('error-request','Error Request',$data);
	}

	public function editAdminPage($adminid='')
	{
		$old = array();
		$data['admin'] = $this->common->getsData("admin",array("adminid"=>$adminid));
		//$data['admin_list'] = $this->common->getData("admin",array("admin_type !="=>"sub-parent","sub_adminid"=>$adminid,"sub_adminid"=>""),array("admin_name","sub_adminid"));
		$admin_list = $this->db->query('select adminid,admin_name,sub_adminid from admin where admin_type!="sub-parent" and admin_type!="parent" and (sub_adminid="'.$adminid.'" or sub_adminid="")')->result_array();
		$data['admin_list'] = $admin_list;
		$data['adminid'] = $adminid;
		foreach ($admin_list as $key => $value) {
			if($value['sub_adminid']==$adminid) {
				array_push($old, $value['adminid']);
			}
		}
		$data['old'] = $old;
		//echo "<pre>";print_r($data);print_r($admin_list);die;
		$this->loadAdminHtml('edit-admin','edit Admin',$data);
	}

	public function allAdminPage()
	{
		$data['admin'] = $this->admin->getSubAdminInfo(); //$this->common->getData("admin",array("adminid !="=>$this->adminid));
		$this->loadAdminHtml('all-admin','Create Admin',$data);
	}

	public function adminLogPage()
	{
		$date = DATE;
		if(isset($_GET) && $_GET) {
			$date = $_GET['date'];
		}
		$data['date'] = $date;
		$data['admin_log'] = $this->db->query("SELECT AL.login_date,IF(AL.logout_date = '0000-00-00 00:00:00','',AL.logout_date) as logout_date,AL.ipaddress,A.admin_name FROM admin_log AS AL LEFT JOIN admin AS A ON AL.adminid = A.adminid WHERE AL.login_date LIKE '%".$date."%'")->result_array();
		$this->loadAdminHtml('admin-log','Today\'s Admin Log Information',$data);
	}
	/*
	*	Get all the messages sent from the users search result page.
	*	The message show to users on his dashboard.
	*/
	public function sentPopupMessagesPage()
	{
		$date = DATE;
		if(isset($_GET) && $_GET) {
			$date = $_GET['date'];
		}
		$data['date'] = $date;
		$data['post'] = $this->db->query("SELECT PM.*,U.first_name,U.last_name FROM popupMessage AS PM LEFT JOIN user AS U ON PM.userid = U.userid WHERE DATE(PM.created_at) = DATE('".$date."')");
		$this->loadAdminHtml('checked-popup-messages','Check Popup Messages Information',$data);
	}
	public function adminTenderList($adminid='')
	{
		$where = array("T.adminid"=>$adminid);
		$data['tender'] = $this->admin->getFreeTenderInfo($where);
		$this->loadAdminHtml('all-tender','All Tender',$data);
	}
	public function countryListPage()
	{
		$data['country'] = $this->common->getData("country");
		$this->loadAdminHtml('country-list','Country list',$data);
	}
	public function advanceUserSearchPage()
	{
		$this->loadAdminHtml('user-search','Advance User Search');
	}
	public function updateTenders()
    {
    	$users = $this->common->getData("user",array("account_status"=>1,"renewal_date"=>"0000-00-00"),array("userid","account_status","renewal_date","expiry_date"));
    	echo count($users)."<br>";
    	if($users){
	    	foreach ($users as $key => $value) {
	    		echo $value['account_status']." = ".$value['userid']." = ".$value['renewal_date']." = ".$value['expiry_date']."<br>";
	    		//$this->common->updateData("user",array("account_status"=>0),array("userid"=>$value['userid']));
	    	}
	    }
    }

	public function checkEmail()
	{
		$data = $this->db->query('select * from user where product_services like "%?%"')->result_array();
		echo "<pre>";print_r($data);
		die;
	}

	public function adminAllotUsersPage($value='')
	{
		$this->is_logged_in();
		$admin = $this->common->getsData("admin",array("adminid"=>$this->adminid));
		$data['registration'] = $this->getUserRegistration(array("U.admin_name"=>$admin['admin_name']));
		$this->loadAdminHtml("admin-alloted-user","Admin Alloted User",$data);
	}

	public function genericDomainsListPage()
	{
		$data['emails'] = $this->common->getData("mail_domain",'','',array("field"=>"mdid","by"=>"desc"));
		$this->loadAdminHtml("mail-domain-list","Mail Domains List",$data);
	}

	public function corporateDomainsListPage()
	{
		$data['emails'] = $this->common->getData("corporate_domain",'','',array("field"=>"cdid","by"=>"desc"));
		$this->loadAdminHtml("corporate-domain-list","Corporate Domains List",$data);
	}

	public function writeNotesPage()
	{
		$data['notes'] = $this->db->query("select N.*,A.admin_name as updated_by,A1.admin_name as created_by from notes as N left join admin as A on N.updatedid = A.adminid left join admin as A1 on N.createdid = A1.adminid ")->result_array();
		$this->loadAdminHtml("write-notes","Notes List",$data);
	}

    public function downloadNotesExcel()
    {
        $this->load->library('PHPExcel');
        $this->load->library('PHPExcel/IOFactory');

        $merge = $this->db->query("select N.*,A.admin_name as updated_by,A1.admin_name as created_by from notes as N left join admin as A on N.updatedid = A.adminid left join admin as A1 on N.createdid = A1.adminid ")->result_array();

        $objPHPExcel = new PHPExcel();

        // Assign cell values
        $objPHPExcel->setActiveSheetIndex(0);
        $objPHPExcel->getActiveSheet()->setTitle("Notes");
        $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
        $objPHPExcel->getActiveSheet()
                                ->setCellValue('A1', 'Created By')
                                ->setCellValue('B1', 'Title')
                                ->setCellValue('C1', 'Description')
                                ->setCellValue('D1', 'Last Edited By');
        if($merge){
            $c = 1;
            foreach ($merge as $key => $value) {
            	$c++;
                $objPHPExcel->getActiveSheet()
                                        ->setCellValue('A'.$c, $value['created_by'])
                                        ->setCellValue('B'.$c, $value['title'])
                                        ->setCellValue('C'.$c, $value['description'])
                                        ->setCellValue('D'.$c, $value['updated_date']);
            }
        }

        $filename='Notes_Excel.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");
        //echo $this->benchmark->elapsed_time('code_start', 'code_end');
    }

	public function allUsersNotesPage($userid='')
	{
		$where = array();
		if($this->admintype != "parent") {
			$where = array("UN.created_by"=>$this->adminid);
		}
		$data['notes'] = $this->usearch->getUserNotesInfo($where);
		$this->loadAdminHtml("all-users-notes","All Users Notes List",$data);
	}

	public function addUserProfilePage()
	{
		$data['package'] = $this->config->item("package");
		$data['country'] = $this->config->item("countryarray");
		$data['tender_sector'] = $this->config->item("sector_industry");
		$data['user_title'] = $this->config->item("title");
		$data['hear'] = $this->config->item("hear");
		$data['admin_type'] = $this->session->userdata('admin_type');
		$data['country_region'] = $this->config->item("country_region");
        $data['notice_type_search'] = $this->config->item("notice_type_search");
		$this->loadAdminHtml("add-user-profile","Add User Profile",$data);
	}

	public function createTable()
	{
		$this->load->library('PHPExcel');
		$this->load->library('PHPExcel/IOFactory');

		$objPHPExcel = new PHPExcel();
		$objPHPExcel->getProperties()->setTitle("title")
		                 ->setDescription("description");
		                        
		// Assign cell values
		$objPHPExcel->setActiveSheetIndex(0);
		$objPHPExcel->getActiveSheet()->setCellValue('A1', 'cell value here');

		$filename='just_some_random_name.xls'; //save our workbook as this file name
		header('Content-Type: application/vnd.ms-excel'); //mime type
		header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
		header('Cache-Control: max-age=0'); //no cache

		// Save it as an excel 2003 file
		$objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
		$objWriter->save("php://output");
	}

	function logout()
	{
		if(isset($this->adminid) && $this->adminid!=""){
			$this->db->query("UPDATE admin_log set logout_date = '".NOW."' where adminid = '".$this->adminid."' and logout_date = '0000-00-00 00:00:00' and login_date like '%".DATE."%' and ipaddress = '".IPA."'");
		}
		$this->session->unset_userdata('adminid');
		$this->session->unset_userdata('admin_type');
		$this->session->unset_userdata('is_admin_logged_in');
		redirect(base_url("admin-login"));
	}
}