<?php 
class Email_Alerts_Model extends CI_Model
{
	public function getAllotedUsers()
	{
		$this->db->select("U.userid,U.admin_name,U.title,U.first_name,U.last_name,U.email,A.adminid");
		$this->db->from("user as U");
		$this->db->join("admin as A","U.admin_name=A.admin_name","left");
		$res = $this->db->get()->result_array();
		return $res;
	}

	public function getUsersCPV($where=array(),$email_alert=1,$table='user')
	{
		$this->db->select("U.u_id,U.userid,U.admin_name,U.title,U.first_name,U.last_name,U.email,
                            U.organization,U.mobile_no,U.email_alert,U.alert_start,U.alert_end,
                            U.product_services,U.omit_product_services,U.sector,U.omit_sector,
                            U.sector_check,U.region_name,U.omit_region_name,U.notice_type,
                            U.country,U.extra_email,U.expiry_date,U.city,U.phone,U.website_url,
                            U.package,U.password,U.suspend,U.reg_date,SC.saved_cpv,EA.frequency,
                            EA.frequency_limit,EA.count_alert,EA.payment_status,A.email as admin_email");//,count(ST.userid) as count_st_log
		$this->db->from($table." as U");
        $this->db->join("saved_cpv as SC","U.userid=SC.userid","left");
        $this->db->join("email_alert as EA","U.userid=EA.userid","left");
        $this->db->join("admin as A","U.admin_name=A.admin_name","left");
		//$this->db->join("st_log as ST","U.userid=ST.userid","left outer");
        ($email_alert==1)?$this->db->where("U.email_alert",1):"";
        $this->db->where("U.suspend",0);
        if($where){
            $this->db->where($where);
        }
		$res = $this->db->get()->result_array();
        if(isset($res[0]['sector']) && $res[0]['sector']!=""){
            $res[0]['sector'] = $this->common->changeSectorCode($res[0]['sector']);
        }
		return $res;
	}

    public function checkgetUsersCPV($where=array(),$email_alert=1)
    {
        print_r($where);//count(ST.userid) as count_st_log 
        $query = "(SELECT U.u_id,U.userid,U.admin_name,U.title,
                U.first_name,U.last_name,U.email,U.organization,U.mobile_no,U.email_alert,
                U.alert_start,U.alert_end,U.product_services,U.sector,U.sector_check,
                U.region_name,U.notice_type,U.country
                ,SC.saved_cpv,EA.frequency,EA.frequency_limit,EA.count_alert,A.email as admin_email,count(ST.userid) as count_st_log 
                    from user as U 
                    left join saved_cpv as SC on U.userid=SC.userid 
                    left join email_alert as EA on U.userid=EA.userid 
                    left join admin as A on U.admin_name=A.admin_name 
                    left outer join st_log as ST on U.userid=ST.userid where U.userid!='' ";
        if($email_alert==1){
            $query .= " and U.email_alert";
        }
        if($where){
            foreach ($where as $key => $value) {
                $query .= " and ".$key." = ".$value;
            }
        }
        $query .= " group by ST.userid)";
        //echo $query;
        $res = $this->db->query($query)->result_array();
        return $res;
    }

    public function getTendersContentForCPVAlerts($get=array(),$other=array(),$fp='')
    {
        $where='';
        $like=0;
        $data1['post'] = $this->tender->getRows($get,$where,array(),'tenders',0);
        return $data1;
    }

    public function sendTemplateOnMail($html='',$to='',$bcc='',$subject='')
    {
        $this->email->from($bcc,'Global Tenders');
        $this->email->to($to);
        $this->email->subject($subject);
        $this->email->message($html);
        if($bcc){
            $this->email->bcc($bcc);
        }
        if($this->email->send()){

            return 1;
        }else{
            return 0;
        }
    }

    public function getMailSubjectTemplate($userdata=array(),$edit_temp='',$temp='')
    {
        $template = $this->getTemplateHtml($userdata,$edit_temp);
        $subject = $this->alert->getTemplateSubject($userdata,$temp);
        $subject = $this->alert->getEditedSubject($userdata,$subject);
        return array("template"=>$template,"subject"=>$subject);
    }

    public function getTemplateHtml($userdata=array(),$edit_temp='')
    {
        $template = str_replace("\$title", $userdata['title'], $edit_temp);
        $template = str_replace("\$first_name", $userdata['first_name'], $template);
        $template = str_replace("\$last_name", $userdata['last_name'], $template);
        $template = str_replace("\$email", $userdata['email'], $template);
        $template = str_replace("\$organization", $userdata['organization'], $template);
        $template = str_replace("\$city", $userdata['city'], $template);
        $template = str_replace("\$country", $userdata['country'], $template);
        $template = str_replace("\$phone", $userdata['phone'], $template);
        $template = str_replace("\$mobile_no", $userdata['mobile_no'], $template);
        $template = str_replace("\$website_url", $userdata['website_url'], $template);
        $template = str_replace("\$sector", $userdata['sector'], $template);
        $template = str_replace("\$admin_name", $userdata['admin_name'], $template);
        $template = str_replace("\$product_services", $userdata['product_services'], $template);
        $template = str_replace("\$saved_cpv", ($userdata["saved_cpv"]=='[""]' || $userdata["saved_cpv"]=="")?"No CPV Saved!":$userdata["saved_cpv"], $template);
        $template = str_replace("\$region_name", $userdata['region_name'], $template);
        $template = str_replace("\$package", $userdata['package'], $template);
        $template = str_replace("\$password", $userdata['password'], $template);
        return $template;
    }

    public function getEditedSubject($userdata=array(),$subject='')
    {
        $subject = str_replace("\$first_name", $userdata['first_name'], $subject);
        $subject = str_replace("\$last_name", $userdata['last_name'], $subject);
        $subject = str_replace("\$country", $userdata['country'], $subject);
        return $subject;
    }

    public function getTemplateSubject($userdata=array(),$template='')
    {
        $subject='';
        switch ($template) {
            case 'template1':
                $subject = "Global Tenders Subscription – ".(isset($userdata['first_name'])?$userdata['first_name']:"\$first_name")." ".(isset($userdata['last_name'])?$userdata['last_name']:"\$last_name")." (".(isset($userdata['country'])?$userdata['country']:"\$country").")";
                break;
            case 'template2':
                $subject = "Global Tenders Subscription – ".(isset($userdata['first_name'])?$userdata['first_name']:"\$first_name")." ".(isset($userdata['last_name'])?$userdata['last_name']:"\$last_name")." (".(isset($userdata['country'])?$userdata['country']:"\$country").")";
                break;
            case 'template3':
                $subject = "Global Tenders Relationship Manager";
                break;
            case 'template4':
                $subject = "Global Tenders Relationship Manager";
                break;
            case 'template5':
                $subject = "Subscribe for Business Opportunities";
                break;
            case 'template6':
                $subject = "Subscribe for Business Opportunities";
                break;
            case 'template7':
                $subject = (isset($userdata['first_name'])?$userdata['first_name']:"\$first_name").", Have I lost you";
                break;
            case 'template8':
                $subject = (isset($userdata['first_name'])?$userdata['first_name']:"\$first_name").", Have I lost you";
                break;
            case 'template9':
                $subject = "Global Tenders Services";
                break;
            case 'template10':
                $subject = "Global Tenders Analytics";
                break;
            case 'template11':
                $subject = "Global Tenders Subscription Activated - ".(isset($userdata['first_name'])?$userdata['first_name']:"\$first_name")." ".(isset($userdata['last_name'])?$userdata['last_name']:"\$last_name")." (".(isset($userdata['organization'])?$userdata['organization']:"\$organization").")";
                break;
            case 'template12':
                $subject = "Global Tenders Subscription Activated - ".(isset($userdata['first_name'])?$userdata['first_name']:"\$first_name")." ".(isset($userdata['last_name'])?$userdata['last_name']:"\$last_name")." (".(isset($userdata['organization'])?$userdata['organization']:"\$organization").")";
                break;
            case 'template13':
                $subject = "Global Tenders Subscription Expiring - ".(isset($userdata['first_name'])?$userdata['first_name']:"\$first_name")." ".(isset($userdata['last_name'])?$userdata['last_name']:"\$last_name")." (".(isset($userdata['organization'])?$userdata['organization']:"\$organization").")";
                break;
            case 'template14':
                $subject = "Global Tenders Subscription Expired - ".(isset($userdata['first_name'])?$userdata['first_name']:"\$first_name")." ".(isset($userdata['last_name'])?$userdata['last_name']:"\$last_name")." (".(isset($userdata['organization'])?$userdata['organization']:"\$organization").")";
                break;
            case 'verificationHtml':
                $subject = "Verify your Global Tenders Account";
                break;
        }
        return $subject;
    }

    public function usersSearchedTendersToSend($ep=array(),$userid='',$limit=10,$count=0,$tender_type="live")
    {
        $table = (isset($ep['table'])?$ep['table']:"user");
        $cpv = $this->dashboard->getUserDashboardSearchFields($userid);

        $profile = $this->common->getsData($table,array("userid"=>$userid),array("sector_check"));
        
        $get['tender_type'] = $tender_type;
        $get['limit'] = "";
        $get['cpv'] = ($cpv['saved_cpv']!="" && $cpv['saved_cpv'] !='[""]')?implode(",", json_decode($cpv['saved_cpv'])):"";

        if($profile['sector_check']==1){

            if($cpv['sector']!=""){
                $get['sector'] = explode(",", $cpv['sector']);
            }
        }

        if($cpv['omit_sector']!=""){
            $get['omit_sector'] = explode(",", $cpv['omit_sector']);
        }

        $get['keyword'] = $cpv['product_services'];
        $get['omit_keyword'] = $cpv['omit_product_services'];
        if($cpv['region_name']!=""){
            $get['region_name'] = explode(",", $cpv['region_name']);
        }else{
            $get['region_name'] = array();
        }
        if($cpv['omit_region_name']!=""){
            $get['omit_region_name'] = explode(",", $cpv['omit_region_name']);
        }else{
            $get['omit_region_name'] = array();
        }
        $get['notice_type'] = $cpv['notice_type'];
        //print_r($get);
        $data = $this->tender->getRows($get,'',array("limit"=>$limit),"tenders",$count);
        return $data;
    }

    public function getUsersAdminEmail($userid='')
    {
        $this->db->select("U.userid,A.email as admin_email");
        $this->db->from("user as U");
        $this->db->join("admin as A","U.admin_name=A.admin_name","left");
        $this->db->where("U.userid",$userid);
        $res = $this->db->get()->result_array();
        if($res && !empty($res)){
            return $res[0];
        }else{
            return false;
        }
    }

    public function createZipFile($filename='',$content='',$zipname='')
    {
        if(!is_file ("assets/csv_files/".$filename)){

            fopen("assets/csv_files/".$filename, "w");
            file_put_contents ("assets/csv_files/".$filename, $content);

            $this->load->library('zip');
            $this->zip->add_data($filename, $content);
            $this->zip->archive("assets/csv_files/".$zipname.".zip");
            unlink("assets/csv_files/".$filename);
            //$res=true;
            return true;
        }else{
            return false;
        }
    }

    public function advanceDailyAlertSearch($get=array(),$baseurl='',$search_function='dailyAlertSearch')
    {
        //echo "<pre>";print_r($get);
        $like=0;
        $page = (isset($get['limit']) && $get['limit'])?$get['limit']:0;
        if($page==0){
            $offset = 0;
            $where = array('limit'=>$this->perPage);
        }else{
            $offset = $page;
            $where = array('start'=>$offset,'limit'=>$this->perPage);
        }
        //$t1=$t2=array();
        $totalRec = $this->$search_function($get,array(),1);
        $data1['post'] = $this->$search_function($get,$where,0);
        //echo "<pre>";print_r($data1);die;
        $config=array(
                'target' => '#postList',
                'base_url' => $baseurl,
                'total_rows' => $totalRec,
                'per_page' => $this->perPage,
                'full_tag_open' => "<ul class='pagination pagination-sm no-margin pull-right'>",
                'full_tag_close' => "</ul>",
                'first_tag_open' => '<li>',
                'first_tag_close' => '</li>',
                'last_tag_open' => '<li>',
                'last_tag_close' => '</li>',
                'next_tag_open' => '<li>',
                'next_tag_close' => '</li>',
                'prev_tag_open' => '<li>',
                'prev_tag_close' => '</li>',
                'num_tag_open' => '<li>',
                'num_tag_close' => '</li>',
                'cur_tag_open' => "<li class='active'><a>",
                'cur_tag_close' => "</a></li>"
            );
        $this->pagination->initialize($config);

        $data1['links'] = $this->pagination->create_links();
        $data1['h1'] = $this->pagination->totalRecords();
        $data1['h2'] = $this->pagination->noOfRecords();

        return $data1;
    }

    public function dailyAlertSearch($post=array(),$params = array(),$count='')
    {
        $fields = $query = $wh = $like = $table = '';
        $s=$regi=$con=$regcon=0;
        if($count==0){
            $fields = "DMH.userid,DMH.send_date,U.title,U.first_name,U.last_name,U.email,U.country,U.reg_date,U.organization,U.admin_name";
        }else{
            $fields = "DMH.userid";
        }
        $table = "daily_mail_history";
        //U.userid,U.title,U.first_name,U.last_name,U.email,U.account_status,U.renewal_date,U.expiry_date,U.country,U.organization,U.password,U.suspend,U.alert_start,U.alert_end,U.admin_name,U.email_alert,U.hear,U.sector
        //$this->load->database("info");
        $query .= 'select '.$fields.' from '.$table.' as DMH left join user as U on DMH.userid=U.userid where DMH.dahid!=""';

        if((isset($post['date_from']) && $post['date_from']!='') && (isset($post['date_to']) && $post['date_to']!='')) {
            $wh.=($post['date_from'])?" and ( DATE(DMH.seen_date) >= '".$post['date_from']."' and DATE(DMH.seen_date) <= '".$post['date_to']."' )":"";

        }else if((isset($post['date_from']) && $post['date_from']!='') && (isset($post['date_to']) && $post['date_to']=='')) {
            $wh.=($post['date_from'])?" and ( DATE(DMH.seen_date) = '".$post['date_from']."' )":"";

        }elseif((isset($post['date_from']) && $post['date_from']=='') && (isset($post['date_to']) && $post['date_to']!='')) {
            $wh.=($post['date_to'])?" and ( DATE(DMH.seen_date) = '".DATE($post['date_to'])."' )":"";

        }
        if(isset($post['userid']) && $post['userid']!='') {
            $wh.=($post['userid'])?' and ( U.userid = "'.$post['userid'].'" )':'';
        }
        if(isset($post['country']) && $post['country']!='') {
            $wh.=($post['country'])?' and ( U.country = "'.$post['country'].'" )':'';
        }
        if(isset($post['email']) && $post['email']!='') {
            $wh.=($post['email'])?' and ( U.email = "'.$post['email'].'" )':'';
        }
        if(isset($post['send_date']) && $post['send_date']!='') {
            $wh.=($post['send_date'])?' and ( DATE(DMH.send_date) = "'.DATE($post['send_date']).'" )':'';
        }
        if($this->admintype!="parent"){
            $wh.=' and ( U.admin_name = "'.$this->adminname.'" )';
        }
        $query.=$wh.$like;
        
        $query.=' order by DMH.send_date desc ';
        if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $query.=' limit '.$params['start'].', '.$params['limit'];
        }
        if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $query.=' limit '.$params['limit'];
        }

        $rquery=$this->db->query($query);
        //echo "<pre>";print_r($query->result_array());
        if($count==0){
            //echo $this->db->last_query()."<br>";
            $result = $rquery->result_array();
            $this->session->set_userdata("daily_alert_search",$query);
            //echo "<pre>";print_r($result);echo "</pre>";die;
        }else{
            $result = $rquery->num_rows();
            //echo "count = ".$result."<br>";
        }
        //$this->otherFilters($query->result_array(),$other);
        $rquery->free_result();
        return $result;
    }
}
?>