<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Global_Tender_Dashboard_Model extends CI_Model 
{
	public function getSavedTenders()
	{
		$tenders = array();
		$data = $this->common->getsData("dashboard",array("userid"=>$this->userid),array("posting_id"));
		$posting_id = json_decode($data['posting_id']);
		if($posting_id){
			foreach ($posting_id as $key => $value) {
				$tender = $this->tender->getTenders(array("posting_id"=>$value));
				$tenders[] = $tender;
			}
		}
		return $tenders;
	}

	public function getDashboardTendersContent($get=array(),$function=array(),$condition=array(),$other=array())
	{
		$where='';$like=0;
		$page = $get['limit'];
		if(!$page){
            $offset = 0;
            $where1 = array('limit'=>$this->perPage);
        }else{
            $offset = $page;
            $where1 = array('start'=>$offset,'limit'=>$this->perPage);
        }
        //print_r($where);
        //total rows count
        $totalRec = $this->dashboard->$function($get,$where,array(),$condition,1);
        //echo $this->db->last_query();
        $config['target']      = '#postList';
        $config['base_url']    = base_url();
        $config['total_rows']  = $totalRec;
        $config['per_page']    = $this->perPage;
        
        $this->pag->initialize($config);
        
        $data1['post'] = $this->dashboard->$function($get,$where,$where1,$condition,0);
        if($this->input->post('ajax')) {
        	$data1['html'] = getTenders($data1["post"],'',$other);
        }
        else {
        	$data1['html'] = getTenders($data1["post"],'',$other);
    	}
        $data1['links'] = $this->pag->create_links();
        $data1['h1'] = $this->pag->totalRecords();
        $data1['h2'] = $this->pag->noOfRecords();

        return $data1;
	}

    public function getAllTenders($post=array(),$where='',$params = array(),$condition=array())
    {
        $other=array();
        $res = false;
        $infodb = $this->load->database('info', TRUE);
        $infodb->select("T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type");
        $infodb->from("tenders as T");
        //$this->db->join("notice_type as NT","T.notice_type=NT.nt_id","left");
        //$this->db->join("country as C","T.country=C.country_code","left");
        if($condition)
        {
            $infodb->where($condition);
        }
        $infodb->order_by("T.posting_id","desc");
        if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $infodb->limit($params['limit'], $params['start']);
        }
        if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $infodb->limit($params['limit']);
        }
        $result = $infodb->get()->result_array();
        //$result = $this->tender->otherFilters($res->result_array(),$other);
        return $result;
    }

    public function getArchivesTenders($post=array(),$where='',$params = array(),$condition=array(),$count='')
    {
        $other=array();
        $res = false;
        $infodb = $this->load->database('info', TRUE);
        $infodb->select("T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type");
        $infodb->from("tenders_archive as T");
        if($condition)
        {
            $infodb->where($condition);
        }
        $infodb->order_by("T.posting_id","desc");
        if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $infodb->limit($params['limit'], $params['start']);
        }
        if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $infodb->limit($params['limit']);
        }
        if($count==1){
            $result = $infodb->get()->num_rows();
        }else{
            $result = $infodb->get()->result_array();
        }
        //$result = $this->tender->otherFilters($res->result_array(),$other);
        return $result;
    }

    public function getSavedTendersData($post=array(),$where='',$params = array(),$condition=array(),$count='')
    {
        $other=array();
        $res = false;
        //echo $this->userid;
        $data = $this->common->getsData("saved_tenders",array("userid"=>$this->userid),array("posting_id"));
        //print_r($data);die;
        if($data["posting_id"]!="" && $data["posting_id"]!="[]"){
            $posting_id = json_decode($data['posting_id']);
            $infodb = $this->load->database('info', TRUE);
            $infodb->select("T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type");
            $infodb->from("tenders as T");
            //$this->db->join("notice_type as NT","T.notice_type=NT.nt_id","left");
            //$this->db->join("country as C","T.country=C.country_code","left");
            if($data)
            {
                foreach ($posting_id as $key => $value) {
                    if($key==0){
                        $infodb->where("T.posting_id",$value);
                    }else{
                        $infodb->or_where("T.posting_id",$value);
                    }
                }
            }
            if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
                $infodb->limit($params['limit'], $params['start']);
            }
            if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
                $infodb->limit($params['limit']);
            }
            if($count==1){
                $result = $infodb->get()->num_rows();
            }else{
                $result = $infodb->get()->result_array();
            }
            //$result = $this->tender->otherFilters($res->result_array(),$other);
            return $result;
        }
    }

	public function getSentTenders($post=array(),$where='',$params = array(),$condition=array(),$count='')
    {
        $res = false;
    	//echo $this->userid;
    	$data = $this->common->getData("sent_tenders",array("userid"=>$this->userid),array("posting_id"));
        //print_r($data);die;
        if($data!=""){
        	$this->db->select("T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.p_id,T.country,T.region,T.currency,T.est_cost,T.cpv,NT.notice_type_name,C.country_name");
        	$this->db->from("tenders as T");
        	$this->db->join("notice_type as NT","T.notice_type=NT.nt_id","left");
        	$this->db->join("country as C","T.country=C.country_code","left");
        	if($data)
        	{
        		foreach ($data as $key => $value) {
        			if($key==0){
        				$this->db->where("T.posting_id",$value['posting_id']);
        			}else{
        				$this->db->or_where("T.posting_id",$value['posting_id'] );
        			}
        		}
        	}
        	if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
    			$this->db->limit($params['limit'], $params['start']);
    		}
    		if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
    			$this->db->limit($params['limit']);
    		}
            if($count==1){
                $result = $infodb->get()->num_rows();
            }else{
                $result = $infodb->get()->result_array();
            }
    		//$res = $this->db->get();
            //$result = $this->tender->otherFilters($res->result_array(),$other);
        }
        return $result;
    }

    public function getDashboardTenders($post=array(),$where='',$params = array())
    {
        $other=array();
        $res = false;
        $k1=0;
        $wherelike4=$query='';
        $query .= 'select T.sector,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.p_id,T.country,T.region,T.currency,T.est_cost,T.cpv,NT.notice_type_name,C.country_name from tenders as T ';
        if(isset($post['cpv']) && $post['cpv']!="")
        {
            $cpv = json_decode($post['cpv']);
            if($cpv)
            {
                foreach ($cpv as $key => $value) :
                    if($key==0)
                    {
                        $wherelike4.=' T.cpv like "%'.$value.'%" or T.cpv like "%,'.$value.'%" ';
                    }else{
                        $wherelike4.=' or T.cpv like "%'.$value.'%" or T.cpv like "%,'.$value.'%" ';
                    }
                endforeach;
            }
        }
        $query.=($wherelike4)?" where ".$wherelike4:"";
        if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $query.=' limit '.$params['start'].', '.$params['limit'];
        }
        if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $query.=' limit '.$params['limit'];
        }
        $query=$this->db->query($query);
        $result = $this->tender->otherFilters($query->result_array(),$other);
        $query->free_result();
        return $result;
    }

    public function getNewTenders($post=array(),$where='',$params = array(),$condition=array())
    {
        $res = false;
        $login = $this->common->getsData("user",array("userid"=>$this->userid),array("last_login"));
        $last = $login['last_login'];
        $this->db->select("T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type");
        $this->db->from("tenders as T");
        //$this->db->join("notice_type as NT","T.notice_type=NT.nt_id","left");
        //$this->db->join("country as C","T.country=C.country_code","left");
        if($last)
        {
            if($last!="0000-00-00 00:00:00")
            {
                $now = date("Y-m-d");
                $this->db->where("T.date_c >=",$last);
                $this->db->where("T.date_c <=",$now);
            }
            //$this->db->where($condition);
        }
        if(array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $this->db->limit($params['limit'], $params['start']);
        }
        if(!array_key_exists("start",$params) && array_key_exists("limit",$params)){
            $this->db->limit($params['limit']);
        }
        $result = $this->db->get()->result_array();
        //$other=array();
        //$result = $this->tender->otherFilters($res->result_array(),$other);
        return $result;
    }

    public function updateuserKeyword($userid='',$post=array())
    {
        $re = '/^\d+(?:,\d+)*$/';
        if ( preg_match($re, $post['saved_cpv']) || $post['saved_cpv']==""){
        
            $cpv = $this->common->getsData("saved_cpv",array("userid"=>$userid));
            if($cpv && $cpv['saved_cpv']!=''){
                //echo "yes";
                //print_r(preg_replace("/[a-zA-Z]+/","",$post['saved_cpv']));die;
                $cpv = json_encode(explode(",", preg_replace("/[a-zA-Z]+/","",str_replace(" ", "",reduce_multiples($post['saved_cpv'],',')))));
                //print_r($cpv);
                $this->common->updateData("saved_cpv",array("saved_cpv"=>$cpv),array("userid"=>$userid));
            }else{
                //echo "no";
                $data['userid'] = $userid;
                $data['saved_cpv'] = json_encode(explode(",", str_replace(" ", "", $post['saved_cpv'])));
                //print_r($data);
                if(isset($cpv['saved_cpv']) && $cpv['saved_cpv']=='')
                {
                    $this->common->updateData("saved_cpv",array("saved_cpv"=>reduce_multiples($data['saved_cpv'],',')),array("userid"=>$userid));
                }else{
                    $this->common->insertData("saved_cpv",$data);
                }
            }
        }else{
            $this->session->set_flashdata("emessage","Please Fill the correct CPV.");
        }
        return true;
    }

    public function getUserDashboardSearchFields($userid='')
    {
        $this->db->select("U.product_services,U.omit_product_services,U.sector,U.omit_sector,U.region_name,U.omit_region_name,U.notice_type,SC.saved_cpv");
        $this->db->from("user as U");
        $this->db->join("saved_cpv as SC","U.userid=SC.userid","left");
        $this->db->where("U.userid",$userid);
        $res = $this->db->get()->result_array();
        if($res){
            return $res[0];
        }else{
            return false;
        }
    }

    public function updateKeywordDashboard($userid='',$product_services=array())
    {
        $get = array();
        // $get['date_c_start'] = DATE;
        // $get['date_c_end'] = DATE;
        $get['tender_type'] = "live";
        $get['fields'] = "posting_id,short_desc";
        // $this->db->query("truncate table user_keyword_search");
        $product_services = explode(",", $product_services);
        $count = array();
        if(isset($product_services) && $product_services!=""){
            foreach ($product_services as $key3 => $value3) {
                if (!array_key_exists($value3, $count)) {
                    $count[$value3] = 0;
                }
                $get['keyword'] = $value3;
                $tenders = $this->tender->getRows($get,'',array(),"tenders",1);
                if ($tenders > 0) {
                    $count[$value3] = $tenders;
                }
            }
            if ($this->common->getsData("user_keyword_search",array("userid"=>$userid))) {
                $this->common->updateData("user_keyword_search",array("keyword_search"=>json_encode($count)),array("userid"=>$userid));
            }else{
                $this->common->insertData("user_keyword_search",array("userid"=>$userid,"keyword_search"=>json_encode($count),"date"=>NOW));
            }
        }else{
            $this->common->updateData("user_keyword_search",array("keyword_search"=>json_encode($count)),array("userid"=>$userid));
        }
    }
}