<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Report extends MY_Admin_Controller {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		echo "Report Controller Called.";
	}

	public function marketReportPage()
	{
		$array = array('table' => "market_report");
		$data = $this->report->advanceReportSearch($array);
		$this->loadAdminHtml("market_report_list","Market Report List",$data);
	}

	public function analyticsReportPage()
	{
		$array = array('table' => "analytics_report");
		$data = $this->report->advanceReportSearch($array);
		$this->loadAdminHtml("analytics_report_list","Analytics Report List",$data);
	}

	public function periodicUpdatesReportPage()
	{
		$array = array('table' => "periodic_updates_report");
		$data = $this->report->advanceReportSearch($array);
		$this->loadAdminHtml("periodic_updates_list","Periodic Updates Report List",$data);
	}

	public function freeUsersRequestPage()
	{
		$data = $this->report->advanceReportSearch(array(),"","freeUsersRequest");
		$this->loadAdminHtml("free-users-request","Periodic Updates Report List",$data);
	}

	public function yearWiseRegistrationReport()
	{
		$report = array();
		if(isset($_GET['type']) && $_GET['type'] == "year") {
			$query = "SELECT DATE_FORMAT(reg_date,'%Y') AS reg_date,email_domain,count(email_domain) as count
			FROM user ";
			$query .= "GROUP BY DATE_FORMAT(reg_date,'%Y'),email_domain";
			$result = $this->db->query($query)->result_array();
			if($result) {
				foreach ($result as $key => $value) {
					if(!array_key_exists($value['reg_date'], $report)) {
						$report[$value['reg_date']] = array();
					}

					if(array_key_exists($value['reg_date'], $report)) {
						if(!isset($report[$value['reg_date']]['generic_count']) && $value['email_domain'] == "generic") {
							$report[$value['reg_date']]['generic_count'] = $value['count'];
						}
						if(!isset($report[$value['reg_date']]['corporate_count']) && $value['email_domain'] == "corporate") {
							$report[$value['reg_date']]['corporate_count'] = $value['count'];
						}
						if(!isset($report[$value['reg_date']]['corporate_taken_count']) && $value['email_domain'] == "corporate taken") {
							$report[$value['reg_date']]['corporate_taken_count'] = $value['count'];
						}
					}
				}

			}
		}
		if(isset($_GET['download']) && $_GET['download']=="excel") {
			$this->load->library('PHPExcel');
        	$this->load->library('PHPExcel/IOFactory');

        	$objPHPExcel = new PHPExcel();

	        $objPHPExcel->setActiveSheetIndex(0);
	        $objPHPExcel->getActiveSheet()->setTitle("Year Wise Registration");
	        $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
	        $objPHPExcel->getActiveSheet()
	                                ->setCellValue('A1', 'Year')
	                                ->setCellValue('B1', 'Generic Count')
	                                ->setCellValue('C1', 'Corporate Count')
	                                ->setCellValue('D1', 'Corporate Taken Count')
	                                ->setCellValue('E1', 'Total');
			
			// echo "<pre>";
			// print_r ($_GET);
			// print_r ($report);
			// echo "</pre>";die;
			if($report) {
				$c = 1;
				$corporate_total = $corporate_taken_total = $generic_total = array();
				foreach ($report as $key => $value) {
					$c++;
					$corporate_generic_count = array();
                    $corporate_value = $generic_value = $corporate_taken_value = "";
                    if(isset($value['corporate_count'])){ 
                        $corporate_value = $value['corporate_count'];
                        array_push($corporate_total, $corporate_value);
                        array_push($corporate_generic_count, $corporate_value);
                    }else{
                        $corporate_value = 0;
                    }
                    if(isset($value['corporate_taken_count'])){ 
                        $corporate_taken_value = $value['corporate_taken_count'];
                        array_push($corporate_taken_total, $corporate_taken_value);
                        array_push($corporate_generic_count, $corporate_taken_value);
                    }else{
                        $corporate_taken_value = 0;
                    }
                    if(isset($value['generic_count'])){ 
                        $generic_value = $value['generic_count'];
                        array_push($generic_total, $generic_value);
                        array_push($corporate_generic_count, $generic_value);
                    }else{
                        $generic_value = 0;
                    }
					$objPHPExcel->getActiveSheet()
                                    ->setCellValue('A'.$c, $key)
                                    ->setCellValue('B'.$c, $generic_value)
                                    ->setCellValue('C'.$c, $corporate_value)
                                    ->setCellValue('D'.$c, $corporate_taken_value)
                                    ->setCellValue('E'.$c, array_sum($corporate_generic_count));
				}
				$c++;
				$gt = array_sum($generic_total);
				$ct = array_sum($corporate_total);
				$ctt = array_sum($corporate_taken_total);
				$objPHPExcel->getActiveSheet()
                                    ->setCellValue('A'.$c, "Total")
                                    ->setCellValue('B'.$c, $gt)
                                    ->setCellValue('C'.$c, $ct)
                                    ->setCellValue('D'.$c, $ctt)
                                    ->setCellValue('E'.$c, ($gt+$ct+$ctt));
			}

			$filename='year-wise-registration.xls'; //save our workbook as this file name
	        header('Content-Type: application/vnd.ms-excel'); //mime type
	        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
	        header('Cache-Control: max-age=0'); //no cache

	        // Save it as an excel 2003 file
	        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
	        $objWriter->save("php://output");die;
		}
		$data['report'] = $report;
		$this->loadAdminHtml("year-wise-registration","Year Wise Registration",$data);
	}

	public function monthWiseRegistrationReport()
	{
		$report = array();
		if(isset($_GET['year']) && $_GET['year'] != "") {
			$query = "SELECT DATE_FORMAT(reg_date,'%M') AS reg_date,email_domain,count(email_domain) as count
			FROM user WHERE DATE_FORMAT(reg_date,'%Y') = ".$_GET['year'];
			$query .= " GROUP BY DATE_FORMAT(reg_date,'%m'),email_domain";
			$result = $this->db->query($query)->result_array();
			if($result) {
				foreach ($result as $key => $value) {
					if(!array_key_exists($value['reg_date'], $report)) {
						$report[$value['reg_date']] = array();
					}

					if(array_key_exists($value['reg_date'], $report)) {
						if(!isset($report[$value['reg_date']]['generic_count']) && $value['email_domain'] == "generic") {
							$report[$value['reg_date']]['generic_count'] = $value['count'];
						}
						if(!isset($report[$value['reg_date']]['corporate_count']) && $value['email_domain'] == "corporate") {
							$report[$value['reg_date']]['corporate_count'] = $value['count'];
						}
						if(!isset($report[$value['reg_date']]['corporate_taken_count']) && $value['email_domain'] == "corporate taken") {
							$report[$value['reg_date']]['corporate_taken_count'] = $value['count'];
						}
					}
				}
			}
		}
		if(isset($_GET['download']) && $_GET['download']=="excel") {
			$this->load->library('PHPExcel');
        	$this->load->library('PHPExcel/IOFactory');

        	$objPHPExcel = new PHPExcel();

	        $objPHPExcel->setActiveSheetIndex(0);
	        $objPHPExcel->getActiveSheet()->setTitle("Month Wise Registration");
	        $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
	        $objPHPExcel->getActiveSheet()
	                                ->setCellValue('A1', 'Year')
	                                ->setCellValue('B1', 'Generic Count')
	                                ->setCellValue('C1', 'Corporate Count');
			
			if($report) {
				$c = 1;
				$corporate_total = $corporate_taken_total = $generic_total = array();
				foreach ($report as $key => $value) {
					$c++;
					$corporate_generic_count = array();
                    $corporate_value = $generic_value = $corporate_taken_value = "";
                        if(isset($value['corporate_count'])){ 
                            $corporate_value = $value['corporate_count'];
                            array_push($corporate_total, $corporate_value);
                            array_push($corporate_generic_count, $corporate_value);
                        }else{
                            $corporate_value = 0;
                        }
	                    if(isset($value['corporate_taken_count'])){ 
	                        $corporate_taken_value = $value['corporate_taken_count'];
	                        array_push($corporate_taken_total, $corporate_taken_value);
	                        array_push($corporate_generic_count, $corporate_taken_value);
	                    }else{
	                        $corporate_taken_value = 0;
	                    }
                        if(isset($value['generic_count'])){ 
                            $generic_value = $value['generic_count'];
                            array_push($generic_total, $generic_value);
                            array_push($corporate_generic_count, $generic_value);
                        }else{
                            $generic_value = 0;
                        }
					$objPHPExcel->getActiveSheet()
                                    ->setCellValue('A'.$c, $key)
                                    ->setCellValue('B'.$c, $generic_value)
                                    ->setCellValue('C'.$c, $corporate_value)
                                    ->setCellValue('D'.$c, $corporate_taken_value)
                                    ->setCellValue('E'.$c, array_sum($corporate_generic_count));
				}
				$c++;
				$gt = array_sum($generic_total);
				$ct = array_sum($corporate_total);
				$ctt = array_sum($corporate_taken_total);
				$objPHPExcel->getActiveSheet()
                                    ->setCellValue('A'.$c, "Total")
                                    ->setCellValue('B'.$c, $gt)
                                    ->setCellValue('C'.$c, $ct)
                                    ->setCellValue('D'.$c, $ctt)
                                    ->setCellValue('E'.$c, ($gt+$ct+$ctt));
			}

			$filename='month-wise-registration-'.$_GET['year'].'.xls'; //save our workbook as this file name
	        header('Content-Type: application/vnd.ms-excel'); //mime type
	        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
	        header('Cache-Control: max-age=0'); //no cache

	        // Save it as an excel 2003 file
	        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
	        $objWriter->save("php://output");die;
		}
		$data['report'] = $report;
		$this->loadAdminHtml("month-wise-registration","Month Wise Registration",$data);
	}

	public function countryWiseRegistrationReport()
	{
		$report = array();
		if(isset($_GET['year']) && $_GET['year'] != "") {
			$query = "SELECT DATE_FORMAT(reg_date,'%M') AS reg_date,country,email_domain,count(email_domain) as count
			FROM user WHERE DATE_FORMAT(reg_date,'%Y') = ".$_GET['year'];
			$query .= " GROUP BY country,email_domain";
			$result = $this->db->query($query)->result_array();
			if($result) {
				foreach ($result as $key => $value) {
					if(!array_key_exists($value['country'], $report)) {
						$report[$value['country']] = array();
					}

					if(array_key_exists($value['country'], $report)) {
						if(!isset($report[$value['country']]['generic_count']) && $value['email_domain'] == "generic") {
							$report[$value['country']]['generic_count'] = $value['count'];
						}
						if(!isset($report[$value['country']]['corporate_count']) && $value['email_domain'] == "corporate") {
							$report[$value['country']]['corporate_count'] = $value['count'];
						}
						if(!isset($report[$value['country']]['corporate_taken_count']) && $value['email_domain'] == "corporate taken") {
							$report[$value['country']]['corporate_taken_count'] = $value['count'];
						}
						if(!isset($report[$value['country']]['country'])) {
							$report[$value['country']]['country'] = $value['country'];
						}
					}
				}
			}
		}

		if(isset($_GET['download']) && $_GET['download']=="excel") {
			$this->load->library('PHPExcel');
        	$this->load->library('PHPExcel/IOFactory');

        	$objPHPExcel = new PHPExcel();

	        $objPHPExcel->setActiveSheetIndex(0);
	        $objPHPExcel->getActiveSheet()->setTitle("Country Wise Registration");
	        $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
	        $objPHPExcel->getActiveSheet()
	                                ->setCellValue('A1', 'Year')
	                                ->setCellValue('B1', 'Generic Count')
	                                ->setCellValue('C1', 'Corporate Count')
	                                ->setCellValue('D1', 'Corporate Taken Count')
	                                ->setCellValue('E1', 'Total');
			
			if($report) {
				$c = 1;
				$corporate_total = $generic_total = $corporate_taken_total = array();
				foreach ($report as $key => $value) {
					$c++;
					$corporate_generic_count = array();
                    $corporate_value = $generic_value = $corporate_taken_value = "";
                        if(isset($value['corporate_count'])){ 
                            $corporate_value = $value['corporate_count'];
                            array_push($corporate_total, $corporate_value);
                            array_push($corporate_generic_count, $corporate_value);
                        }else{
                            $corporate_value = 0;
                        }
                        if(isset($value['corporate_taken_count'])){ 
                            $corporate_taken_value = $value['corporate_taken_count'];
                            array_push($corporate_taken_total, $corporate_taken_value);
                            array_push($corporate_generic_count, $corporate_taken_value);
                        }else{
                            $corporate_taken_value = 0;
                        }
                        if(isset($value['generic_count'])){ 
                            $generic_value = $value['generic_count'];
                            array_push($generic_total, $generic_value);
                            array_push($corporate_generic_count, $generic_value);
                        }else{
                            $generic_value = 0;
                        }
					$objPHPExcel->getActiveSheet()
                                    ->setCellValue('A'.$c, $key)
                                    ->setCellValue('B'.$c, $generic_value)
                                    ->setCellValue('C'.$c, $corporate_value)
                                    ->setCellValue('D'.$c, $corporate_taken_value)
                                    ->setCellValue('E'.$c, array_sum($corporate_generic_count));
				}
				$c++;
				$gt = array_sum($generic_total);
				$ct = array_sum($corporate_total);
				$ctt = array_sum($corporate_taken_total);
				$objPHPExcel->getActiveSheet()
                                    ->setCellValue('A'.$c, "Total")
                                    ->setCellValue('B'.$c, $gt)
                                    ->setCellValue('C'.$c, $ct)
                                    ->setCellValue('D'.$c, $ctt)
                                    ->setCellValue('E'.$c, ($gt+$ct+$ctt));
			}

			$filename='country-wise-registration-'.$_GET['year'].'.xls'; //save our workbook as this file name
	        header('Content-Type: application/vnd.ms-excel'); //mime type
	        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
	        header('Cache-Control: max-age=0'); //no cache

	        // Save it as an excel 2003 file
	        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
	        $objWriter->save("php://output");die;
		}
		$data['report'] = $report;
		// echo "<pre>";
		// print_r ($data);
		// echo "</pre>";die;
		$this->loadAdminHtml("country-wise-registration","Country Wise Registration",$data);
	}

	public function downloadMarketReportExcel($id='')
	{
		$report = $this->common->getsData("market_report",array("id"=>$id));
		$data['keyword'] = $report['keyword'];
		$data['sector'] = explode(",",$report['sector']);
		$data['region_name'] = explode(",", $report['region_name']);
		$data['fields'] = 'T.date_c,T.posting_id,T.maj_org,T.short_desc,T.country,T.doc_last,T.notice_type,T.tender_sector,T.cpv';
		$data['cpv'] = $report['cpv'];
		if($report['published'] == "live") {
			$data['tender_type'] = $report['published'];
		}else{
			$data['tender_type'] = "live";
			$data['date_c_start'] = $report['date_c_start'];
			$data['date_c_end'] = $report['date_c_end'];
		}
		$saved_cpv = (isset($data['cpv']) && $data['cpv']!="")?explode(",", $data['cpv']):array();
		$sector = (isset($report['sector']) && $report['sector']!="")?explode(",", ($report['sector'])):array();
		$product_services = (isset($data['keyword']) && $data['keyword']!="")?explode(",", $data['keyword']):array();
		$tenders = $this->tender->getRows($data,'',array(),'tenders');
		$this->usearch->downloadExcelThreeReport($tenders,$saved_cpv,$sector,$product_services);
	}

	public function sendMarketReportMail()
	{
		$report = $this->common->getsData("market_report",array("id"=>$_GET['id']));
		// $type = ($_GET['mailtype']!="custom")?"Custom Profile":"Saved Profile";
		$user = $this->common->getsData("user",array("userid"=>$_GET['userid']));
		// $message = 'Dear, '.$user['first_name']." ".$user['last_name']."<br>";
		// $message .= 'As you requested for the market report according to your '.$type.'.<br> 
		// 			We maintain a market report from '.$report["date_c_start"].' to '.$report["date_c_end"].'.<br>
		// 			Please Find the link below to download the file.<br>';
		// $message .= '<a href="'.base_url("report/downloadMarketReportExcel/".$_GET['id']).'" title="Download The Market Report.">Market Report.</a>';
		$data['user'] = $user;
		$data['link'] = base_url("report/downloadMarketReportExcel/".$_GET['id']);
		$message = $this->load->view("email-report/market-report-template.php",$data,true);
		$subject = "Market Report";
		$res = $this->common->sendMailByCurl(array("message"=>$message,"from"=>"care@globaltenders.email","to"=>$user['email'],"subject"=>$subject,"bcc"=>"rohan@globaltenders.com,hw.sharma9@gmail.com"));
		//print_r($res);
		if($res['status'] == 1) {
			$this->common->updateData("market_report",array("market_report_send_status"=>1,"send_date"=>NOW),array("id"=>$_GET['id']));
			echo 1;
		}else{
			echo 0;
		}die;
	}

	public function downloadAnalyticsReportExcel($id='')
	{
		$report = $this->common->getsData("analytics_report",array("id"=>$id));
		$data['keyword'] = $report['keyword'];
		$data['sector'] = explode(",",$report['sector']);
		$data['region_name'] = explode(",", $report['region_name']);
		$data['fields'] = 'T.date_c,T.posting_id,T.maj_org,T.short_desc,T.country,T.doc_last,T.notice_type,T.tender_sector,T.cpv,T.region';
		$data['cpv'] = $report['cpv'];
		if($report['published'] == "live") {
			$data['tender_type'] = $report['published'];
		}else{
			$data['tender_type'] = "live";
			$data['date_c_start'] = $report['date_c_start'];
			$data['date_c_end'] = $report['date_c_end'];
		}

		$tenders = $this->tender->getRows($data,'',array(),'tenders');

		// echo "<pre>";
		// print_r ($data);
		// print_r ($tenders);
		// echo "</pre>";

		$objPHPExcel = new PHPExcel();

		$objPHPExcel = $this->usearch->downloadExcel1($objPHPExcel,$tenders,0);
		$objPHPExcel->createSheet();
		$objPHPExcel = $this->usearch->downloadExcel2($objPHPExcel,$tenders,1);
		$objPHPExcel->createSheet();
		$objPHPExcel = $this->usearch->downloadExcel3($objPHPExcel,$tenders,2);
		$objPHPExcel->createSheet();
		$objPHPExcel = $this->usearch->downloadExcel4($objPHPExcel,$tenders,3);
		$objPHPExcel->createSheet();
		$objPHPExcel = $this->usearch->downloadExcel5($objPHPExcel,$tenders,4);
		$objPHPExcel->createSheet();
		$objPHPExcel = $this->usearch->downloadExcel6($objPHPExcel,$tenders,5);
		$objPHPExcel->createSheet();
		$objPHPExcel = $this->usearch->downloadExcel7($objPHPExcel,$tenders,$data['cpv'],6);

        $filename='AllExcel.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

		die;
	}

	public function sendAnalyticsReportMail()
	{
		$report = $this->common->getsData("analytics_report",array("id"=>$_GET['id']));
		$user = $this->common->getsData("user",array("userid"=>$_GET['userid']));
		// $message = 'Dear, '.$user['first_name']." ".$user['last_name']."<br>";
		// $message .= 'As you requested for the analytics report according to your Saved Profile.<br> 
		// 			We maintain a analytics report from '.$report["date_c_start"].' to '.$report["date_c_end"].'.<br>
		// 			Please Find the link below to download the file.<br>';
		// $message .= '<a href="'.base_url("report/downloadAnalyticsReportExcel/".$_GET['id']).'" title="Download The Analytics Report.">Analytics Report.</a>';
		$data['user'] = $user;
		$data['link'] = base_url("report/downloadAnalyticsReportExcel/".$_GET['id']);
		$message = $this->load->view("email-report/market-report-template.php",$data,true);
		$subject = "Analytics Report";
		$res = $this->common->sendMailByCurl(array("message"=>$message,"from"=>"care@globaltenders.email","to"=>$user['email'],"subject"=>$subject,"bcc"=>"rohan@globaltenders.com,hw.sharma9@gmail.com"));
		//print_r($res);
		if($res['status'] == 1) {
			$this->common->updateData("analytics_report",array("analytics_report_send_status"=>1,"send_date"=>NOW),array("id"=>$_GET['id']));
			echo 1;
		}else{
			echo 0;
		}die;
	}

	public function periodicUpdatesMailReportPage($userid)
	{
		$data['user'] = $this->common->getsData("user",array("userid"=>$userid),array("first_name","last_name"));
		$data['mail'] = $this->common->getData("periodic_updates_send_mail_report",array("userid"=>$userid));
		$this->loadAdminHtml("periodic-updates-mail-report","Periodic Updates Mail Report",$data);
	}

	public function sendFreeReportExcel()
	{
		$report = $this->common->getsData("analytics_report",array("id"=>$_GET['id']));
		$user = $this->common->getsData("user",array("userid"=>$_GET['userid']));
		$data['user'] = $user;
		$data['link'] = base_url("assets/reports/".$_GET['mailtype'].".xlsx");
		$message = $this->load->view("email-report/market-report-template.php",$data,true);
		$subject = "Analytics Report";
		$res = $this->common->sendMailByCurl(array("message"=>$message,"from"=>"care@globaltenders.email","to"=>$user['email'],"subject"=>$subject,"bcc"=>""));
		//print_r($res);
		if($res['status'] == 1) {
			// $this->common->updateData("analytics_report",array("analytics_report_send_status"=>1,"send_date"=>NOW),array("id"=>$_GET['id']));
			echo 1;
		}else{
			echo 0;
		}die;
	}

}

/* End of file report.php */
/* Location: .//C/Users/ABC/AppData/Local/Temp/fz3temp-2/report.php */