<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Tender_login extends MY_Controller {

	public function __construct() { 
		parent::__construct();
		$this->load->model('login_model','login');
		// $this->is_logged_in();
		$this->load->helper("cookie");
		$this->load->helper("form");
		$this->load->library('form_validation');
	}

	function is_logged_in()
	{
		$is_user_logged_in = (isset($_COOKIE['is_user_logged_in']))?$_COOKIE['is_user_logged_in']:0;
		if(isset($is_user_logged_in) || $is_user_logged_in == true)
		{
			$urstatus = $this->common->getsData("user_registration_status",array("userid"=>$this->userid));
			if(is_array($urstatus) && $urstatus){
				if($urstatus['register_pages_no'] == 1){
					redirect(base_url("global-tenders-registration2.php"));
				}
				if($urstatus['register_pages_no'] == 2){
					redirect(base_url("dashboard.php"));
				}
			}
		}
	}

	public function userLoginPage()
	{
		if(isset($_POST) && $_POST){
			$this->form_validation->set_rules('email', 'Email', 'trim|required|valid_email');
			$this->form_validation->set_rules('password', 'Password', 'trim|required');
			if ($this->form_validation->run() == FALSE)
	        {
	        	$this->login->insertTrackUserLogin($_POST,0);
				$this->load->view('login');
	        }
	        else
	        {
	        	$this->form_validation->set_rules('error', 'Error', 'callback_emailpassword_check');
				if ($this->form_validation->run() == FALSE)
		        {
		        	$this->login->insertTrackUserLogin($_POST,0);
					$this->load->view('login');
				}else{
	        		$data = $this->common->getsData('user',array('email'=>$_POST['email'],'password'=>$_POST['password']),array("title","email","password","gt_username","gt_password","gt_id","userid","first_name","last_name","last_login","expiry_date","suspend","account_status","renewal_date","expiry_date","varify"));
		        	$this->login->insertTrackUserLogin($_POST,1);
		        	$data['remember'] = $this->login->setPreCookies($data);
					$this->loginRedirect($data);
				}
	        }
		}else{
			$this->load->view('login');
		}
	}

	public function loginRedirect($data=array())
	{
		$this->login->setCookies($data);
		if($this->session->userdata("current")) {

			$redirect = base_url($this->session->userdata("current"));
			($this->session->userdata("current"))?$this->session->unset_userdata("current"):'';
		}else{
			$redirect = base_url("dashboard.php");
		}
		redirect($redirect,"refresh");
		//header('Content-type: application/json; charset=utf-8"');
		//echo json_encode(array("redirect"=>$redirect,"success"=>1));
	}

	public function emailpassword_check()
	{
		if(isset($_POST['email']) && isset($_POST['password'])) {
			$data = $this->common->getsData('user',array('email'=>$_POST['email'],'password'=>$_POST['password']),array("email","password","suspend","varify"));
			if($data) {
				if(($data['email']!=$_POST['email']) || ($data['password']!=$_POST['password'])) {
					$this->form_validation->set_message('emailpassword_check', 'Email or password wrong!');
					return FALSE;
				}/*else if($data['suspend']==1) {
					$this->form_validation->set_message('emailpassword_check', "You account has been suspended.");
					return FALSE;
				}else if($data["varify"]==0){
					$this->form_validation->set_message('emailpassword_check', "You are not a varified user. Talk to Administrator.");
					return FALSE;
				}*/else{
					return TRUE;
				}
			}else{
				$this->form_validation->set_message('emailpassword_check', 'Email-id or Password Not Found!');
				return FALSE;
			}
		}
	}

	public function forgotPasswordPage()
	{
		$this->load->view('forgot-password');
	}

	public function resetPassword()
	{
		if ((isset($_GET['id']) && $_GET['id']!="") || (isset($_GET['id']) && $_GET['id'] != "")) {
			$user = $this->common->getsData("user",array("userid"=>$_GET['id']),array("u_id","userid","email","password"));
			if ($_GET['chk'] == base64_encode($user['u_id'].$user['userid'].$user['email'].$user['password'])) {
				$this->load->view('reset-password',$user);
			}else{
				$this->session->set_flashdata("emessage","This link for reset password has been expired!");
				redirect(base_url('tender-login/sign-up.php'),'refresh');
			}
		}else{
			redirect(base_url(),'refresh');
		}
	}

	public function resetPasswordAction()
	{
		$this->common->updateData("user",array("password"=>$_POST['password']),array("userid"=>$_POST['userid']));
		$data = $this->common->getsData('user',array('email'=>$_POST['email'],'password'=>$_POST['password'],"userid"=>$_POST['userid']),array("title","email","password","gt_username","gt_password","gt_id","userid","first_name","last_name","last_login","expiry_date","suspend","account_status","renewal_date","expiry_date","varify"));
		$this->loginRedirect($data);
	}

	public function forgetPassword()
	{
		$email = $_POST['email'];
		if(isset($email)) {

			if($data = $this->common->getsData('user',array('email'=>$email))) {

				$password = $data['password'];
			    $this->common->updateData('user',array('password'=>$password),array('userid'=>$data['userid']));
			    $email_message = "Dear ".$data['first_name']."<br><br>Please <a href='".base_url("reset-password?id=".$data['userid']."&chk=".base64_encode($data['u_id'].$data['userid'].$data['email'].$data['password']))."'>click here</a> to reset the password<br><br>Best Regards,<br><br>Global Tenders Admin";//, Your password is ".$password."
				$data['message'] = $email_message;
				$data['from'] = "admin@globaltenders.email";
				$data['to'] = $email;
				$data['subject'] = 'Global Tenders Password Recovery - '.$data['first_name']." ".$data['last_name'];
				$data['bcc'] = 'admin@globaltenders.com';
				$result = $this->common->sendMailByCurl($data);
		        if($result['status'] == 1){
					$this->session->set_flashdata("message",$this->lang->line('password_reset'));
					redirect(base_url('tender-login/sign-up.php'),'refresh');
				}else{
					$this->session->set_flashdata("emessage",$this->lang->line("error_reset_password"));
					redirect(base_url('global-tenders-forgot-password'),'refresh');
				}
			}else{
				$this->session->set_flashdata("emessage","Email Not Found.");
				redirect(base_url('global-tenders-forgot-password'),'refresh');
			}
		}
	}

	public function userRegistrationPage1()
	{
		if ($this->userid!="") {
			redirect(base_url('dashboard.php'),'refresh');
		}
		if(isset($_POST) && $_POST){
			$this->form_validation->set_rules('email', 'Email', 'required|valid_email|callback_email_check');
			$this->form_validation->set_rules('password', 'Password', 'required|min_length[8]|max_length[16]');
			$this->form_validation->set_rules('package', 'Package', 'trim|required');
			if ($this->form_validation->run() == FALSE)
	        {
				$this->load->view('registration-step1');
	        }
	        else
	        {
	            $res = $this->login->userRegistrationAction1($_POST);
	            if($res){
	            	redirect(base_url('global-tenders-registration2.php'),'refresh');
	            }
	        }
		}else{
			$this->load->view('registration-step1');
		}
	}

    public function registerUserStep2Page()
    {
    	if(isset($_GET["userid"]) && $_GET["userid"]!=""){
    		if($data = $this->common->getsData("user",array("userid"=>$_GET["userid"],"varify"=>0))){
    			if($_GET['userid'] <= 1524197447) {
    				$this->common->updateData("user",array("varify"=>1),array("userid"=>$_GET["userid"],"varify"=>0));
    			}else{
					if(isset($_GET['det']) && $_GET['det']!="") {
						if(base64_encode($data['u_id'].$data['userid'].$data['email'].$data['password']) == $_GET['det']) {
							$this->common->updateData("user",array("varify"=>1),array("userid"=>$_GET["userid"],"varify"=>0));
						}else{
			    			redirect(base_url("global-tenders-registration"));
			    		}
					}else{
		    			redirect(base_url("global-tenders-registration"));
		    		}
    			}
    			//redirect(base_url("global-tenders-registration-step2?userid=".$_GET["userid"]."&name=".$data["first_name"]." ".$data['last_name']."&email=".$data['email']));
    			if(isset($this->userid) && $this->userid!="") {
    				redirect(base_url('dashboard.php'),'refresh');
    			}else{
    				$this->loginRedirect($data);
    			}
    		}else{
    			redirect(base_url("global-tenders-registration"));
    		}
    	}else{
    		redirect(base_url("global-tenders-registration"));
    	}
    }

	public function email_check($email)
    {
    	$exp = explode("@", $email);
    	$exp = end($exp);
        $junk_mail = $this->config->item("junk_mail");
        $data = $this->db->query('select email from user where email = "'.$email.'"')->num_rows();
        if (in_array($exp, $junk_mail) || $data>0)
        {
            $this->form_validation->set_message('email_check', 'The %s already has an account on Global Tenders.');
            return FALSE;
        }
        else
        {
            return TRUE;
        }
    }

	public function userRegistrationPage2()
	{
		if ($this->userid=="") {
			redirect(base_url('global-tenders-registration'),'refresh');
		}else{
			$user_registration_status = $this->common->getsData("user_registration_status",array("userid"=>$this->userid));
			if($user_registration_status && $user_registration_status['register_pages_no'] == 2) {
				redirect(base_url('dashboard.php'),'refresh');
			}
		}
		if(isset($_POST) && $_POST){
			$this->form_validation->set_rules('first_name', 'First Name', 'trim|required|alpha|callback_fname_check');
			$this->form_validation->set_rules('last_name', 'Last Name', 'trim|required|alpha|callback_lname_check');
			$this->form_validation->set_rules('organization', 'Organization', 'trim|required|callback_organization_check');
			$this->form_validation->set_rules('country', 'Country', 'trim|required');
			//$this->form_validation->set_rules('mobile_no', 'Mobile Number', 'trim|numeric|min_length[10]|max_length[12]');
			$this->form_validation->set_rules('mobile_no', 'Mobile Number', 'trim|required|numeric');
			$this->form_validation->set_rules('sector', 'Sector', 'trim|required');
			if ($this->form_validation->run() == FALSE)
	        {
				$this->load->view('registration-step2');
	        }
	        else
	        {
	            $res = $this->login->userRegistrationAction2($_POST);
	            if($res){
	            	redirect(base_url('dashboard.php'),'refresh');
	            }
	        }
		}else{
			$this->load->view('registration-step2');
		}
	}

	public function chckClientStatus()
	{
		$client_status = setClientStatus("China");
		echo $client_status;
	}

	public function fname_check($fname)
    {
        $junk_first_name = $this->config->item("junk_first_name");
        if (in_array($fname, $junk_first_name))
        {
            $this->form_validation->set_message('fname_check', 'The {field} Contains Junk Data.');
            return FALSE;
        }
        else
        {
            return TRUE;
        }
    }

	public function lname_check($lname)
    {
    	$junk_last_name = $this->config->item("junk_last_name");
        if (in_array($lname, $junk_last_name))
        {
            $this->form_validation->set_message('lname_check', 'The {field} Contains Junk Data.');
            return FALSE;
        }
        else
        {
            return TRUE;
        }
    }

    public function organization_check($organization='')
    {
    	$junk_organization = $this->config->item("junk_organization");
        if (in_array($organization, $junk_organization))
        {
            $this->form_validation->set_message('organization_check', 'The {field} Contains Junk Data.');
            return FALSE;
        }
        else
        {
            return TRUE;
        }
    }

	public function userRegistrationPage3()
	{
		if ($this->userid=="") {
			redirect(base_url('global-tenders-registration'),'refresh');
		}
		if(isset($_POST) && $_POST){
            $res = $this->login->userRegistrationAction3($_POST);
            if($res){
            	redirect(base_url('dashboard.php'),'refresh');
            }
		}else{
			$this->load->view('registration-step3');
		}
	}

	/*
	*	This function run by cron job and send an email if users do not compleate the 2nd step after 10 minutes.
	*/

    public function checkUserRegistration()
    {
    	$time = date("Y-m-d H:i",strtotime("- 10 minutes",(strtotime(NOW))));
    	$users = $this->db->query('SELECT email,userid,email_domain FROM user WHERE reg_date LIKE "%'.$time.'%"')->result_array();
    	if($users) {
    		foreach ($users as $key => $value) {
    			$reg_status = $this->common->getsData("user_registration_status",array("userid"=>$value['userid']));
    			if($reg_status['register_pages_no']==1) {
    				$array['post'] = $value;
    				if($value['email_domain'] == "generic" || $value['email_domain'] == "corporate taken") {
	    				$data['message'] = $this->load->view("email-templates/generic-compleate-profile",$array,TRUE);
    				}else{
	    				$data['message'] = $this->load->view("email-templates/corporate-compleate-profile",$array,TRUE);
    				}
    				$this->common->insertData("email_track",array("userid"=>$value['userid'],"send_mail_date"=>NOW,"seen_date"=>"","template_name"=>"registration","seen_count"=>0));
					$data['from'] = "contact@globaltenders.email";
					$data['to'] = $value['email'];
					$data['subject'] = "Global Tenders Subscription";
					$data['bcc'] = 'contact@globaltenders.com';
					$result = $this->common->sendMailByCurl($data);
    			}
    		}
    	}
    }

	public function checkEmail()
	{
		$isAvailable=false;
		if($data = $this->common->getsData("user",array("email"=>$_POST['email'])))
		{
			$isAvailable = false;
		}else{
			$isAvailable = true;
		}
		echo json_encode(array(
		    'valid' => $isAvailable,
		));
	}

	public function testMail()
	{
		$data['message'] = "Testing Curl Mail";
		$data['from'] = "contact@globaltenders.email";
		$data['to'] = "harsh.starwebindia@gmail.com";
		$data['subject'] = "check Curl Mail";
		$data['bcc'] = '';
		$result = $this->common->sendMailByCurl($data);
		echo "<pre>";
		var_dump ($result);
		echo "</pre>";
	}

    public function checkSendMail()
    {
        $message = 'testing image';
        $message .= '<img src="'.base_url('tender_login/testImg?userid=12345&img='.base_url("gt-images/shadow.png")).'" />';
        $subject = "Test Mail";
        // echo $message;
        $res = $this->common->sendMailByCurl(array("message"=>$message,"from"=>"care@globaltenders.email","to"=>"hw.sharma9@gmail.com","subject"=>$subject,"bcc"=>""));
        print_r($res);
        if($res['status'] == 1) {
            echo "Mail Sent";
        }
    }

    public function updateUsersMail()
    {
    	$user = $this->common->getData("user",array("country"=>"","client_status"=>""),array("userid","email","country","email_domain"));
    	if($user) {
    		$count = 0;
    		foreach ($user as $key => $value) {
    			$count++;
    			$type = $client_status = "";

				if($value['email_domain'] == "generic") {
					$client_status = "C";
				}else{
					$client_status = setClientStatus($value['country']);
				}
				echo $value['userid']." ".$value['email']." ".$value['email_domain']." ".$client_status."<br>";
				if($client_status!="") {
					// $this->common->updateData("user",array("client_status"=>$client_status),array("userid"=>$value['userid']));
				}
    		}
    		echo "count = ".$count;
    	}
    }

    public function testImg()
    {
    	$_GET['img'] = base_url("gt-images/shadow.png");
        return $_GET['img'];
    }

}
