<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Tender_Search extends MY_Admin_Controller {

    Public function __construct(){
        parent::__construct();
        $this->is_logged_in();
        $this->load->helper('download');
        //$this->perPage=10;
    }

    public function is_logged_in()
    {
        $is_admin_logged_in = $this->session->userdata('is_admin_logged_in');
        if(!isset($is_admin_logged_in) || $is_admin_logged_in != true)
        {
            redirect(base_url("admin-login"));
        }
    }

    public function index()
    {
        $data = $this->common->getDropDowns(array("funding_agency"));
        $data['estimated_cost'] = $this->config->item("estimated_cost");
        $data['country_region'] = $this->config->item("country_region");
        $data['tender_sector'] = $this->config->item("sector_industry");
        $data['notice_type'] = $this->config->item("notice_type");
        $data['tender_closing'] = $this->config->item("deadline");
        $this->loadAdminHtml("tender-search","Tenders",$data);
    }

    public function angularSearch()
    {
        $data = $this->common->getDropDowns(array("funding_agency"));
        $data['estimated_cost'] = $this->config->item("estimated_cost");
        $data['country_region'] = $this->config->item("country_region");
        $data['tender_sector'] = $this->config->item("sector_industry");
        $data['notice_type'] = $this->config->item("notice_type");
        $data['tender_closing'] = $this->config->item("deadline");
        $this->loadAdminHtml("angularsearch","Tenders",$data);
    }

    public function angularTenderSearch()
    {
        $postdata = file_get_contents("php://input");
        $request = json_decode($postdata);
        print_r($request);
    }

    public function advanceTendersSearch($limit='')
    {
        $post = $post1 = array();
        $get=array();
        if($limit!="")
        {
            $post1['limit'] = $limit;
            //$post1['limit'] = $this->perPage;
        }else{
            $post['limit'] = 0;
        }
        
        if(!empty($_POST))
        {
            if(isset($_POST["search"]) && $_POST["search"] == 1)
            {
                unset($_POST["search"],$_POST["submit"]);
                foreach ($_POST as $key => $value) {
                    if($_POST[$key]!="")
                    {
                        $post[$key] = $value;
                    }
                }
                $this->session->set_userdata("tsearch",$post);
            }
        }else{
            $post = $this->session->userdata('tsearch');
            if($limit!="")
            {
                $post['limit'] = $post1['limit'];
            }
        }
        //$this->is_logged_in();
        $data = $this->search->advanceTendersSearch($post); //$this->common->getData("user");
        //$this->session->set_userdata('tender_search_query',$this->db->last_query());
        //echo "<pre>"; echo $this->db->last_query(); print_r($data);die;
        $this->loadAdminHtml("tender-search-result","Tenders",$data);
    }

    public function downloadExcelOne()
    {
        $infodb     = $this->load->database('info', TRUE);
        $query      = explode("limit", $this->session->userdata("tender_search_query"));
        //echo "<pre>".$query[0];die;
        $q          = str_replace("tenders_archive", "tenders", $query[0]);
        $q1         = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.date_c", $q);
        $query[0]   = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.date_c", $query[0]);

        $c1         = $infodb->query($q1)->num_rows();
        $c2         = $infodb->query($query[0])->num_rows();
        $count      = ($c1+$c2);
        //echo $count;

        $query1     = $infodb->query("( ".$q1.") union all (".$query[0]." )");
        //echo $infodb->last_query();
        $result1    = $query1->result_array();
        $query1->free_result();
        $content    = $result1;
        //print_r($content);

        $objPHPExcel = new PHPExcel();
        $this->usearch->downloadExcel1($objPHPExcel,$content,0);

        $filename='Excel1.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

        /*$filename   = "excel1.csv";
        
        $years = $data = $data1 = array();
        foreach ($content as $key => $value) {
            $y = explode("-", $value['date_c']);
            if (!in_array($y[0], $years)) {
                array_push($years, $y[0]);
            }
            if (in_array($y[0], $years)) {
                $data1[$y[0]][] = $value;
                $data[$y[0]] = count($data1[$y[0]]);
            }
        }

        header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Year',
            'Volume',
        ));

        foreach ($data as $key => $value) {
            fputcsv($handle, array(
                $key,
                $value,
            ));
        }
        fputcsv($handle, array(
            'Total',
            $count,
        ));*/
    }

    public function downloadExcelTwo()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        $country        = $this->config->item("countryarray");
        $notice_type    = $this->config->item("notice_type");
        $sector_industry = $this->config->item("sector_industry");
        $filename       = "excel2.csv";

        $q              = str_replace("tenders_archive", "tenders", $query[0]);
        $q1             = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.posting_id,T.tender_sector,T.short_desc,T.country", $q);
        $query[0]       = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.posting_id,T.tender_sector,T.short_desc,T.country", $query[0]);

        $c1             = $infodb->query($q1)->num_rows();
        $c2             = $infodb->query($query[0])->num_rows();
        $count          = ($c1+$c2);
        //echo $count;

        $query1         = $infodb->query("( ".$q1.") union all (".$query[0]." )");
        //echo $infodb->last_query();
        $result1        = $query1->result_array();
        $query1->free_result();
        $content        = $result1;
        //print_r($data);die;

        $objPHPExcel = new PHPExcel();
        $this->usearch->downloadExcel2($objPHPExcel,$content,0);

        $filename='Excel2.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

        /*header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Refrence No.',
            'Short Description',
            'Tender Sector',
            'Country',
        ));

        foreach ($content as $key => $value) {
            $ts=array();
            $exp = explode(",", $value['tender_sector']);
            foreach ($exp as $key1 => $value1) {
                if($value1!="")
                {
                    if(array_key_exists($value1, $sector_industry))
                    {
                        array_push($ts, $sector_industry[$value1]);
                    }
                }
            }
            fputcsv($handle, array(
                $value['posting_id'],
                $value['short_desc'],
                implode(",", $ts),
                (array_key_exists($value['country'], $country)?$country[$value['country']]:"country name"),
            ));
        }
        fputcsv($handle, array(
            'Total',
            '',
            $count,
        ));*/
    }

    public function downloadExcelThree()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        //echo "<pre>";//.$query[0];die;
        $q              = str_replace("tenders_archive", "tenders", $query[0]);
        $q1             = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.country", $q);
        $query[0]       = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.country", $query[0]);

        $c1             = $infodb->query($q1)->num_rows();
        $c2             = $infodb->query($query[0])->num_rows();
        $count          = ($c1+$c2);
        //echo $count;

        $query1         = $infodb->query("( ".$q1.") union all (".$query[0]." )");
        //echo $infodb->last_query();
        $result1        = $query1->result_array();
        $query1->free_result();
        $content        = $result1;
        //print_r($content);

        $country        = $this->config->item("countryarray");
        //print_r($content);echo $count;

        $objPHPExcel = new PHPExcel();
        $this->usearch->downloadExcel3($objPHPExcel,$content,0);

        $filename='Excel3.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

        /*$filename       = "excel3.csv";
        
        $years = $data = $data1 = array();
        foreach ($content as $key => $value) {
            $c          = $value['country'];
            if (!in_array($c, $years)) {
                array_push($years, $c);
            }
            if (in_array($c, $years)) {
                $data1[$c][]    = $value;
                $volume         = count($data1[$c]);
                $data[$c]       = array("country"=>(array_key_exists($c, $country)?$country[$c]:$c),
                                "volume"=>$volume,
                                "percentage"=>number_format((($volume/$count)*100),2,'.','')." %");
            }
        }
        //print_r($data);die;

        header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Country',
            'Volume',
            'Percentage',
        ));

        foreach ($data as $key => $value) {
            fputcsv($handle, array(
                $value['country'],
                $value['volume'],
                $value['percentage'],
            ));
        }
        fputcsv($handle, array(
            'Total',
            $count,
            '',
        ));*/
    }

    public function downloadExcelFour()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        //echo "<pre>";//.$query[0];die;
        $q              = str_replace("tenders_archive", "tenders", $query[0]);
        $q1             = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.region", $q);
        $query[0]       = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.region", $query[0]);

        $c1             = $infodb->query($q1)->num_rows();
        $c2             = $infodb->query($query[0])->num_rows();
        $count          = ($c1+$c2);
        //echo $count;

        $query1         = $infodb->query("( ".$q1.") union all (".$query[0]." )");
        //echo $infodb->last_query();
        $result1        = $query1->result_array();
        $query1->free_result();
        $content        = $result1;

        $objPHPExcel = new PHPExcel();
        $this->usearch->downloadExcel4($objPHPExcel,$content,0);

        $filename='Excel4.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

        // $country        = $this->config->item("countryarray");
        // $region_names   = $this->config->item("region_names");
        //print_r($content);
        //echo $count;


        /*$this->load->helper('download');

        $filename       = "excel4.csv";
        
        $region = $data = $data1 = array();
        $count1         =   0;
        foreach ($content as $key => $value) {
            $r          = explode(",",$value['region']);
            $r1 = $r2 = array();
            foreach ($r as $key1 => $value1) {
                $reg1   = substr($value1, 0, 2);
                //$reg_name1 = (array_key_exists($reg1, $region_names)?$region_names[$reg1]:$value['region']);
                if($reg1!=""){
                    array_push($r1, $reg1);
                }
                if (!in_array($reg1, $region)) {
                    if($reg1!=""){
                        array_push($region, $reg1);
                    }
                }
            }
            $r2=array_unique($r1);
            foreach ($r2 as $key1 => $value1) {
                $reg2 = substr($value1, 0, 2);
                if (in_array($reg2, $region)) {
                    //echo "1<br>";
                    $data1[$reg2][] = $value;
                    $volume         = count($data1[$reg2]);

                    //$reg = substr($value1, 0, 2);
                    $reg_name       = (array_key_exists($reg2, $region_names)?$region_names[$reg2]:$value['region']);

                    $data[$reg2]    = array("region"=>$reg_name,
                                    "volume"=>$volume,
                                    "percentage"=>number_format((($volume/$count)*100),2,'.','')." %");
                }
            }
        }

        header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Region',
            'Volume',
            'Percentage',
        ));

        foreach ($data as $key => $value) {
            fputcsv($handle, array(
                $value['region'],
                $value['volume'],
                $value['percentage'],
            ));
        }
        fputcsv($handle, array(
            'Total',
            $count,
            '',
        ));*/
    }

    public function downloadExcelFive()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        $month          = $this->config->item("months");
        //echo "<pre>";//.$query[0];
        $filename       = "excel5.csv";

        $q              = str_replace("tenders_archive", "tenders", $query[0]);
        $q1             = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.date_c", $q);
        $query[0]       = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.date_c", $query[0]);

        $c1             = $infodb->query($q1)->num_rows();
        $c2             = $infodb->query($query[0])->num_rows();
        $count          = ($c1+$c2);
        //echo $count;

        $query1         = $infodb->query("( ".$q1.") union all (".$query[0]." )");
        //echo $infodb->last_query();
        $result1        = $query1->result_array();
        $query1->free_result();
        $content        = $result1;

        $objPHPExcel = new PHPExcel();
        $this->usearch->downloadExcel5($objPHPExcel,$content,0);

        $filename='Excel5.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

        /*$months = $data = $data1 = array();
        foreach ($content as $key => $value) {
            $y          = explode("-", $value['date_c']);
            if (!in_array($y[1], $months)) {
                array_push($months, $y[1]);
            }
            if (in_array($y[1], $months)) {
                $data1[$y[1]][] = $value;
                $volume         = count($data1[$y[1]]);
                $data[$y[1]]    = number_format((($volume/$count)*100),2,'.','')." %";
            }
        }

        //echo "<pre>"; print_r($data);die;

        header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Month',
            'Percentage',
        ));

        foreach ($data as $key => $value) {
            fputcsv($handle, array(
                (array_key_exists($key, $month)?$month[$key]:"country name"),
                $value,
            ));
        }
        fputcsv($handle, array(
            'Total',
            $count,
        ));*/
    }

    public function downloadExcelSix()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        $month          = $this->config->item("months");
        $country        = $this->config->item("countryarray");
        //echo "<pre>";//.$query[0];
        $filename       = "excel6.csv";

        $q              = str_replace("tenders_archive", "tenders", $query[0]);
        $q1             = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.posting_id,T.maj_org,T.country,T.short_desc", $q);
        $query[0]       = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.posting_id,T.maj_org,T.country,T.short_desc", $query[0]);

        $c1             = $infodb->query($q1)->num_rows();
        $c2             = $infodb->query($query[0])->num_rows();
        $count          = ($c1+$c2);
        //echo $count;

        $query1         = $infodb->query("( ".$q1.") union all (".$query[0]." )");
        //echo $infodb->last_query();
        $result1        = $query1->result_array();
        $query1->free_result();
        $content        = $result1;

        $objPHPExcel = new PHPExcel();
        $this->usearch->downloadExcel6($objPHPExcel,$content,0);

        $filename='Excel6.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");

        /*header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Refrence No.',
            'Major Organization',
            'Country',
            'Short Description'
        ));

        foreach ($content as $key => $value) {
            fputcsv($handle, array(
                $value['posting_id'],
                $value['maj_org'],
                (array_key_exists($value['country'], $country)?$country[$value['country']]:"country name"),
                $value['short_desc']
            ));
        }
        fputcsv($handle, array(
            'Total',
            $count,
            '',
        ));*/
    }

    public function downloadExcelSeven()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        //echo "<pre>".$query[0];
        $filename       = "excel7.csv";
        $post_array     = $this->session->userdata("admin_advance_tender_search");
        $cpv_array=$cpv_array1=array();
        if(isset($post_array['cpv']) && $post_array!=""){
            $q          = str_replace("tenders_archive", "tenders", $query[0]);
            $q1         = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.cpv", $q);
            $query[0]   = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", "T.cpv", $query[0]);

            $c1         = $infodb->query($q1)->num_rows();
            $c2         = $infodb->query($query[0])->num_rows();
            $count      = ($c1+$c2);

            $query1     = $infodb->query("( ".$q1.") union all (".$query[0]." )");
            // echo $infodb->last_query();die;
            $result1    = $query1->result_array();
            $query1->free_result();
            $content    = $result1;

            //print_r($content);
            
            $objPHPExcel = new PHPExcel();
            $this->usearch->downloadExcel7($objPHPExcel,$content,$post_array['cpv'],0);

            $filename='Excel7.xls'; //save our workbook as this file name
            header('Content-Type: application/vnd.ms-excel'); //mime type
            header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
            header('Cache-Control: max-age=0'); //no cache

            // Save it as an excel 2003 file
            $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save("php://output");
        
            /*$cpv        = (isset($post_array['cpv']) && $post_array['cpv']!="")?explode(",", $post_array['cpv']):"";
            if($cpv!=""){
                //print_r($cpv);
                foreach ($cpv as $key => $value) {
                    //echo "<br>".$value;
                    $cpv_array1[] = substr($value,0,2);
                }
            }
            $cpv_array = array_unique($cpv_array1);
            //print_r($cpv_array);
            $qkeys='';
            foreach ($cpv_array as $key => $value) {
                if($key!=0){
                    $qkeys .= "or ";
                }
                $qkeys .= "cpv_code like '".$value."%' ";
            }
            $query      = "select cpv_description,cpv_code from cpv where ".$qkeys;
            $result     = $this->db->query($query)->result_array();
            //echo $query;
            //echo count($result);
            //print_r($result);

            $result_cpv = $data = $data1 = array();
            $count1     = 0;
            foreach ($result as $key => $value) {
                foreach ($content as $key1 => $value1) {
                    if (strpos($value1['cpv'], $value['cpv_code']) !== false) {
                        $data1[$value['cpv_code']][] = $value;
                        $value['count'] = count($data1[$value['cpv_code']]);
                        $value['percentage'] = number_format((($value['count']/$count)*100),2,'.','')." %";
                        $data[$value['cpv_code']] = $value;
                    }
                }
            }
            header("Content-type: application/csv");
            header("Content-Disposition: attachment; filename=".$filename);
            header("Pragma: no-cache");
            header("Expires: 0");

            $handle = fopen('php://output', 'w');
            fputcsv($handle, array(
                'CPV',
                'CPV Code',
                'Number of Tenders',
                'Percent of Total Tenders',
            ));

            foreach ($data as $key => $value) {
                fputcsv($handle, array(
                    $value['cpv_description'],
                    $value['cpv_code'],
                    $value['count'],
                    $value['percentage'],
                ));
            }*/
        }else{
            echo "<h1>No CPV found on search.</h1>";
        }
    }

    public function downloadExcelQuery()
    {
        $infodb     = $this->load->database('info', TRUE);
        $query      = explode("limit", $this->session->userdata("tender_search_query"));
        echo $query[0];
        /*$result = $infodb->query("(select * from tenders as T 
            where ( T.date_c >='2015-01-01' and T.date_c <='2015-12-31' ) 
            and ( T.notice_type IN (1) ) order by T.posting_id desc)
            UNION all
            (select * from tenders_archive as T 
            where ( T.date_c >='2015-01-01' and T.date_c <='2015-12-31' ) 
            and ( T.notice_type IN (1) ) order by T.posting_id desc)
            ")->result_array();
        echo "<pre>"; print_r($result);*/
    }

    public function downloadExcelEight()
    {
        $infodb         = $this->load->database('info', TRUE);
        $query          = explode("limit", $this->session->userdata("tender_search_query"));
        $country        = $this->config->item("countryarray");
        $notice_type    = $this->config->item("notice_type");
        $sector_industry = $this->config->item("sector_industry");
        $filename       = "excel8.csv";

        $q1             = str_replace("tenders_archive", "tenders", $query[0]);

        $q1             = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", 
            "T.posting_id,T.date_c,T.maj_org,T.tender_sector,T.short_desc,T.doc_last,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", $q1);
        $query[0]       = str_replace("T.date_c,T.tender_sector,T.short_desc,T.doc_last,T.posting_id,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", 
            "T.posting_id,T.date_c,T.maj_org,T.tender_sector,T.short_desc,T.doc_last,T.country,T.region,T.currency,T.est_cost,T.cpv,T.notice_type", $query[0]);

        $d1             = $infodb->query($q1)->result_array();
        $d2             = $infodb->query($query[0])->result_array();
        $data           = array_merge($d1,$d2);

        $c1             = $infodb->query($q1)->num_rows();
        $c2             = $infodb->query($query[0])->num_rows();
        $count          = ($c1+$c2);
        //print_r($data);die;

        header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$filename);
        header("Pragma: no-cache");
        header("Expires: 0");

        $handle         = fopen('php://output', 'w');
        fputcsv($handle, array(
            'Posting ID',
            'Date Created',
            'Major Organization',
            'Tender Sector',
            'Short Description',
            'Doc Last',
            'Country',
            'Region',
            'Currency',
            'Estimate Cost',
            'CPV',
            'Notice Type',
            'Link'
        ));

        foreach ($data as $key => $value) {
            $ts=array();
            $exp = explode(",", $value['tender_sector']);
            foreach ($exp as $key1 => $value1) {
                if($value1!="")
                {
                    if(array_key_exists($value1, $sector_industry))
                    {
                        array_push($ts, $sector_industry[$value1]);
                    }
                }
            }
            fputcsv($handle, array(
                $value['posting_id'],
                $value['date_c'],
                $value['maj_org'],
                implode(",", $ts),
                $value['short_desc'],
                $value['doc_last'],
                (array_key_exists($value['country'], $country)?$country[$value['country']]:"country name"),
                $value['region'],
                $value['currency'],
                $value['est_cost'],
                $value['cpv'],
                (array_key_exists($value["notice_type"], $notice_type)?$notice_type[$value["notice_type"]]:"notice type name"),
                base_url("full-detail/".$value['posting_id'])
            ));
        }
        fputcsv($handle, array(
            'Total',
            $count,
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
        ));
    }

    public function checkQuery()
    {
        $live = file_get_contents("http://www.globaltenders.com/search2.php?agency=OPEP&tender_type=live");
        if (strpos($live, 'Sorry, No Record matches your request.') !== false) {
            $archive = file_get_contents("http://www.globaltenders.com/search2.php?agency=World+Bank&tender_type=archive");
            print_r($archive);
        }else{
            print_r($live);
        }
    }
}