<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Tenders_templates extends MY_Admin_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model("Tenders_templates_model","templates");
		$this->load->helper('directory');
		$this->load->helper('file');
	}

	public function createTemplatePage()
	{
		$data['category_list'] = directory_map( FCPATH ."application/views/static_templates",true);
		$this->loadAdminHtml("create-template","Create Templates",$data);
	}

	public function createTemplate()
	{
		$template_name = $this->templates->setFileName($_POST['template_name']);
		if(file_exists(FCPATH .'application/views/static_templates/'.$template_name.'.php')){
			$this->session->set_flashdata("emessage","File with this name already exist.");
			redirect(base_url('tenders_templates/createTemplatePage'),'refresh');
		}
		$result = $this->templates->writeTemplateContent($_POST);
		if($result){
			$this->session->set_flashdata("message","File Created!");
		}else{
			$this->session->set_flashdata("emessage","Unable to create the file.");
		}
		redirect(base_url('admin/templates-list'),'refresh');
	}

	public function templatesListPage($category='templates')
	{
		$data['category_list'] = directory_map( FCPATH ."application/views/static_templates",true);
		$data['category'] = $category;
		$data['files'] = $this->templates->getTemplateFilesList($category);
		$this->loadAdminHtml("templates-list","Create Templates",$data);
	}

	public function editTemplatePage()
	{
		$file_name = $_GET['fn'];
		$category = $_GET['c'];
		$data['category'] = $_GET['c'];
		$data['template_content'] = $this->templates->readTemplateContent($file_name,$category);
		$data['template_name'] = str_replace("_", " ", $file_name);
		if($template = $this->common->getsData("templates",array("template_name"=>$file_name))){
			$data['subject'] = $template['subject'];
		}else{
			$data['subject'] = "";
		}
		$this->loadAdminHtml("edit-template","Edit Templates",$data);
	}
	public function editTemplate()
	{
		if($_POST['old_template_name'] != $_POST['template_name']) {
			if(file_exists(FCPATH .'application/views/static_templates/'.$_POST['category'].'/'.$this->templates->setFileName($_POST['template_name']).'.php')){
				$this->session->set_flashdata("emessage","File with this name already exist.");
				redirect(base_url('admin/edit-templates?fn='.$this->templates->setFileName($_POST['old_template_name']).'&c='.$_POST['category']),'refresh');
			}
		}
		$result = $this->templates->writeTemplateContent($_POST);
		if($result){
			$this->session->set_flashdata("message","File written!");
			redirect(base_url('admin/templates-list/'.$_POST['category']),'refresh');
		}else{
			$this->session->set_flashdata("emessage","Unable to write the file.");
			redirect(base_url('admin/edit-templates?fn='.$this->templates->setFileName($_POST['template_name']).'&c='.$_POST['category']),'refresh');
		}
	}

	public function deleteTemplate()
	{
		$file_name = $_GET['fn'];
		$category = $_GET['c'];
		$result = $this->templates->deleteTemplate($this->templates->setFileName($file_name),$category);
		if($result){
			$this->session->set_flashdata("message","File deleted!");
		}else{
			$this->session->set_flashdata("emessage","Unable to delete the file.");
		}
		redirect(base_url('admin/templates-list'),'refresh');
	}

	public function readTemplatePage()
	{
		$file_name = $_GET['fn'];
		$category = $_GET['c'];
		$this->load->view("static_templates/".$category."/".$file_name);
	}

	public function templatesArray()
	{
		$files = directory_map( FCPATH ."application/views/static_templates",true);
		print_r($files);
		// $mail_template = $this->templates->getTemplateFilesList();
		// echo "<pre>";
		// print_r ($mail_template);
		// echo "</pre>";die;
	}
}
