<?php  if (!defined('BASEPATH'))  exit('No direct script access allowed');
class Tenders_templates_model extends CI_Model
{
	public $data=array();
	function __construct()
	{
		parent::__construct();		
	}

	public function setFileName($file_name='')
	{
		//Trim String
	    $string = trim($file_name);
	    $string = str_replace(" ", "_", $string);
	    return $string;
	}

	public function getTemplateFilesList($category='templates')
	{
		$files = directory_map( FCPATH ."application/views/static_templates/$category");
		return $files;
	}

	public function readTemplateContent($file_name='',$category='')
	{
		$read_file_content = read_file( FCPATH .'application/views/static_templates/'.$category.'/'.$file_name.'.php');
		//$read_file_content = $this->load->view('static_templates/templates/'.$file_name,true);
		return $read_file_content;
	}

	public function writeTemplateContent($post='')
	{
		$data = $post['template_content'];
		$file_name = $this->setFileName($post['template_name']);

		if($this->common->getsData("templates",array("template_name"=>$file_name))){
			$this->common->updateData("templates",array("subject"=>$post['subject']),array("template_name"=>$file_name));
		}else{
			$this->common->insertData("templates",array("subject"=>$post['subject'],"template_name"=>$file_name,"date"=>date("Y-m-d H:i:s")));
		}

		if((isset($post['old_template_name']) && $post['old_template_name']!="") && (str_replace(" ", "_", trim($post['old_template_name'])) != str_replace(" ", "_", trim($post['template_name'])))){
			rename(FCPATH .'application/views/static_templates/'.$post['category'].'/'.$this->setFileName($post['old_template_name']).'.php',FCPATH .'application/views/static_templates/'.$post['category'].'/'.$file_name.'.php');
			return 1;
		}else{
			if ( ! write_file(FCPATH .'application/views/static_templates/'.$post['category'].'/'.$file_name.'.php', $data))
			{
			    return 0;
			}
			else
			{
			    return 1;
			}
		}
	}

	public function deleteTemplate($file_name='',$category='')
	{
		unlink(FCPATH .'application/views/static_templates/'.$category.'/'.$file_name.'.php');
		if(file_exists(FCPATH .'application/views/static_templates/'.$category.'/'.$file_name.'.php')){
			return 0;
		}else{
			$this->common->deleteData("templates",array("template_name"=>$file_name));
			return 1;
		}
	}

	public function dynamicTemplateFileContent($userdata=array(),$post=array(),$category='')
	{
		if(isset($post['edit_template']) && $post['edit_template']!=""){
			$template = $post['edit_template'];
		}else{
			$template = $this->readTemplateContent($post['template'],$category);
		}
		$country_region = $this->config->item("country_region");
		foreach ($userdata as $key => $value) {
			$template = str_replace("\$".$key, $value, $template);


			if($key=="saved_cpv"){
				$cpv = str_replace(array('"',"[","]"), "", $value);
				$template = str_replace("\$cpv", $cpv, $template);
			}

			if($key=="region_name"){
				$region_name = array();
	            foreach (explode(",", $value) as $key1 => $value1) {
	                $region_name[] = (array_key_exists($value1, $country_region)?$country_region[$value1]:"worldwide");
	            }
	            $region_name = implode(",", $region_name);
	            $template = str_replace("\$regions", $region_name, $template);
	        }
		}
		$template = str_replace("\$user_verification", base64_encode($userdata['u_id'].$userdata['userid'].$userdata['email'].$userdata['password']), $template);
		return $template;
	}

	public function dynamicTemplateFileSubject($userdata=array(),$post=array())
	{
		$subject = $this->common->getsData("templates",array("template_name"=>$post['template']),array("subject"));
		//$template = $this->readTemplateContent($post['template']);
		$subject = $subject['subject'];
		$country_region = $this->config->item("country_region");
		foreach ($userdata as $key => $value) {
			$subject = str_replace("\$".$key, $value, $subject);
			if($key=="saved_cpv"){
				$cpv = str_replace(array('"',"[","]"), "", $value);
				$subject = str_replace("\$cpv", $cpv, $subject);
			}

			if($key=="region_name"){
				$region_name = array();
	            foreach (explode(",", $value) as $key1 => $value1) {
	                $region_name[] = (array_key_exists($value1, $country_region)?$country_region[$value1]:"worldwide");
	            }
	            $region_name = implode(",", $region_name);
	            $subject = str_replace("\$regions", $region_name, $subject);
	        }
		}
		return $subject;
	}
}