<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Tracking extends MY_Admin_Controller {

	public function __construct()
	{
		parent::__construct();
        $this->load->helper('directory');
        $this->load->helper('file');
        $this->load->helper('tracking');
        $this->load->library('zip');
        // $this->is_logged_in();
	}
	public function is_logged_in()
	{
		$is_admin_logged_in = $this->session->userdata('is_admin_logged_in');
		if(!isset($is_admin_logged_in) || $is_admin_logged_in != true) {

			redirect(base_url("admin-login"));
		}
	}

	public function userTrackingPage()
	{
		$this->is_logged_in();
		if (isset($_GET) && $_GET) {
			if (isset($_GET['lu_date']) && $_GET['lu_date']!="") {
				$data['lu_data'] = directory_map( FCPATH ."assets/users/lu/0/".$_GET['lu_date']);
			}
			if (isset($_GET['nlu_date']) && $_GET['nlu_date']!="") {
				$data['nlu_data'] = directory_map( FCPATH ."assets/users/nlu/0/".$_GET['nlu_date']);
			}
			if (isset($_GET['tcs_date']) && $_GET['tcs_date']!="") {
				$data['tcs_data'] = directory_map( FCPATH ."assets/users/tcs/0/".$_GET['tcs_date']);
			}
		}
		$data['lu'] = directory_map( FCPATH ."assets/users/lu/0",true);
		$data['nlu'] = directory_map( FCPATH ."assets/users/nlu/0",true);
		$data['tcs'] = directory_map( FCPATH ."assets/users/tcs/0",true);
		if($this->admintype == "sub-parent" || $this->admintype == "child") {
			$userids = $this->db->query("select userid from user where admin_name = '".$this->adminname."'")->result_array();
			$data['userids'] = array_column($userids, "userid");
		}else{
			$data['userids'] = array();
		}
		// echo "<pre>";
		// print_r ($data);
		// echo "</pre>";die;
		//$this->createZip("assets/users/lu/0/".$_GET['lu_date']."/",$_GET['lu_date']);
		$this->loadTrackerHtml("users-tracking-page","Users Tracking Page",$data);
	}

	public function downloadList()
	{
		$this->load->library('PHPExcel');
        $this->load->library('PHPExcel/IOFactory');

		$directories = directory_map( FCPATH ."assets/users/".$_GET['type']."/0/".$_GET['date']."/",true);
		$userids = array();
		if($this->admintype == "sub-parent" || $this->admintype == "child") {
			$userids = $this->db->query("select userid from user where admin_name = '".$this->adminname."'")->result_array();
		}
		$objPHPExcel = new PHPExcel();

		$objPHPExcel->setActiveSheetIndex(0);
	    $objPHPExcel->getActiveSheet()->setTitle("Loggedin Users");
	    $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
	    if($_GET['type'] == "lu") {
		    $objPHPExcel->getActiveSheet()
		                            ->setCellValue('A1', 'S. No.')
		                            ->setCellValue('B1', 'Date')
		                            ->setCellValue('C1', 'File Name')
		                            ->setCellValue('D1', 'User')
		                            ->setCellValue('E1', 'Email')
		                            ->setCellValue('F1', 'Pathname')
		                            ->setCellValue('G1', 'Country')
		                            ->setCellValue('H1', 'IP');
	    }else{
	    	$objPHPExcel->getActiveSheet()
		                            ->setCellValue('A1', 'S. No.')
		                            ->setCellValue('B1', 'Date')
		                            ->setCellValue('C1', 'File Name')
		                            ->setCellValue('D1', 'Pathname')
		                            ->setCellValue('E1', 'Country')
		                            ->setCellValue('F1', 'IP');
	    }
		$c=1;
		foreach ($directories as $key => $value) {
			$show = 0; 
			if($this->admintype == "sub-parent" || $this->admintype == "child") {
				$userid = str_replace(".json", "", $value);
				$admin_userid = $userids;
				if(in_array($userid, $admin_userid)) {
					$show = 1;
				}
			}else{
				$show = 1;
			}
			if($show == 1) {
				$c++;
				$read_file = read_file("assets/users/".$_GET['type']."/0/".$_GET['date']."/".$value);
				$file_data = json_decode($read_file,true);
				if($_GET['type'] == "lu") {
					$objPHPExcel->getActiveSheet()
		                                    ->setCellValue('A'.$c, $key+1)
		                                    ->setCellValue('B'.$c, $file_data['created_at'])
		                                    ->setCellValue('C'.$c, $value)
		                                    ->setCellValue('D'.$c, str_replace("+", " ", $file_data['name']))
		                                    ->setCellValue('E'.$c, ((isset($file_data['email']))?$file_data['email']:""))
		                                    ->setCellValue('F'.$c, "pathname")
		                                    ->setCellValue('G'.$c, ((isset($file_data['country']))?$file_data['country']:""))
		                                    ->setCellValue('H'.$c, "IP");
				}else{
					$objPHPExcel->getActiveSheet()
		                                    ->setCellValue('A'.$c, $key+1)
		                                    ->setCellValue('B'.$c, $file_data['created_at'])
		                                    ->setCellValue('C'.$c, $value)
		                                    ->setCellValue('D'.$c, "pathname")
		                                    ->setCellValue('E'.$c, "Panding Country")//$file_data['country']
		                                    ->setCellValue('F'.$c, "IP");
				}
			}
		}
		$filename='Login-Users-List.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");
		//$this->zip->read_dir("assets/users/".$_GET['type']."/0/".$_GET['date']."/",FALSE);
		// Download the file to your desktop. Name it "my_backup.zip"
		//$this->zip->download($_GET['date'].'.zip');
	}

	public function downloadLinksMultipleList()
	{
		$this->load->library('PHPExcel');
        $this->load->library('PHPExcel/IOFactory');

		$directories = directory_map( FCPATH ."assets/users/".$_GET['type']."/0/".$_GET['date']."/",true);
		$userids = array();
		if($this->admintype == "sub-parent" || $this->admintype == "child") {
			$userids = $this->db->query("select userid from user where admin_name = '".$this->adminname."'")->result_array();
			$userids = array_column($userids,"userid");
		}
		// echo "<pre>";
		// print_r ($directories);
		// echo "</pre>";
		$objPHPExcel = new PHPExcel();

		$c=1;$k=0;
		foreach ($directories as $key => $value) {
			$show = 0; 
			if($this->admintype == "sub-parent" || $this->admintype == "child") {
				$userid = str_replace(".json", "", $value);
				if(in_array($userid, $userids)) {
					$show = 1;
				}
			}else{
				$show = 1;
			}
			if($show == 1) {
				$c++;
				$read_file = read_file("assets/users/".$_GET['type']."/0/".$_GET['date']."/".$value);
				$file_data = json_decode($read_file,true);
				// echo "<pre>";
				// print_r ($file_data);
				// echo "</pre>";die;
				$objPHPExcel->setActiveSheetIndex($k);
			    $objPHPExcel->getActiveSheet()->setTitle($file_data['name']);
			    $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
			    if($_GET['type'] == "lu") {
				    $objPHPExcel->getActiveSheet()
				                            ->setCellValue('A1', 'S. No.')
				                            ->setCellValue('B1', 'Date')
				                            ->setCellValue('C1', 'File Name')
				                            ->setCellValue('D1', 'User')
				                            ->setCellValue('E1', 'Email')
				                            ->setCellValue('F1', 'Pathname')
				                            ->setCellValue('G1', 'Country')
				                            ->setCellValue('H1', 'IP');
			    }else{
			    	$objPHPExcel->getActiveSheet()
				                            ->setCellValue('A1', 'S. No.')
				                            ->setCellValue('B1', 'Date')
				                            ->setCellValue('C1', 'File Name')
				                            ->setCellValue('D1', 'Pathname')
				                            ->setCellValue('E1', 'IP');
			    }
	            // Create a new worksheet, after the default sheet
	            $objPHPExcel->createSheet();
				$c1=1;
				$k++;
				foreach ($file_data['track'][$_GET['date']] as $key1 => $value1) {
					$c1++;
					if($_GET['type'] == "lu") {
						$objPHPExcel->getActiveSheet()
			                                    ->setCellValue('A'.$c1, $key1+1)
			                                    ->setCellValue('B'.$c1, $file_data['created_at'])
			                                    ->setCellValue('C'.$c1, $value)
			                                    ->setCellValue('D'.$c1, str_replace("+", " ", $file_data['name']))
			                                    ->setCellValue('E'.$c1, ((isset($file_data['email']))?$file_data['email']:""))
			                                    ->setCellValue('F'.$c1, $value1['pathname'].((isset($value1['search']))?$value1['search']:""))
			                                    ->setCellValue('G'.$c1, ((isset($file_data['country']))?$file_data['country']:""))
			                                    ->setCellValue('H'.$c1, $value1['IP']);
					}else{
						$objPHPExcel->getActiveSheet()
			                                    ->setCellValue('A'.$c1, $key1+1)
			                                    ->setCellValue('B'.$c1, $file_data['created_at'])
			                                    ->setCellValue('C'.$c1, $value)
			                                    ->setCellValue('D'.$c1, $value1['pathname'])
			                                    ->setCellValue('E'.$c1, $value1['IP']);
					}
				}
			}
		}
		$filename='Login-Users-List.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");
	}

	public function downloadLinksSingleList()
	{
		$this->load->library('PHPExcel');
        $this->load->library('PHPExcel/IOFactory');

		$directories = directory_map( FCPATH ."assets/users/".$_GET['type']."/0/".$_GET['date']."/",true);
		$userids = array();
		if($this->admintype == "sub-parent" || $this->admintype == "child") {
			$userids = $this->db->query("select userid from user where admin_name = '".$this->adminname."'")->result_array();
			$admin_userid = array_column($userids,"userid");
		}
		$objPHPExcel = new PHPExcel();

		$objPHPExcel->setActiveSheetIndex(0);
	    $objPHPExcel->getActiveSheet()->setTitle("Single file Link List");
	    $objPHPExcel->getActiveSheet()->getStyle("1:1")->getFont()->setBold( true );
	    if($_GET['type'] == "lu") {
		    $objPHPExcel->getActiveSheet()
		                            ->setCellValue('A1', 'S. No.')
		                            ->setCellValue('B1', 'Date')
		                            ->setCellValue('C1', 'File Name')
		                            ->setCellValue('D1', 'User')
		                            ->setCellValue('E1', 'Email')
		                            ->setCellValue('F1', 'Pathname')
		                            ->setCellValue('G1', 'Country')
		                            ->setCellValue('H1', 'IP');
		}else{
		    $objPHPExcel->getActiveSheet()
		                            ->setCellValue('A1', 'S. No.')
		                            ->setCellValue('B1', 'Date')
		                            ->setCellValue('C1', 'File Name')
		                            ->setCellValue('D1', 'Pathname')
		                            ->setCellValue('E1', 'IP');
		}

		$c=$c1=1;
		foreach ($directories as $key => $value) {
			$show = 0; 
			if($this->admintype == "sub-parent" || $this->admintype == "child") {
				$userid = str_replace(".json", "", $value);
				if(in_array($userid, $admin_userid)) {
					$show = 1;
				}
			}else{
				$show = 1;
			}
			if($show == 1) {
				$c++;
				$read_file = read_file("assets/users/".$_GET['type']."/0/".$_GET['date']."/".$value);
				$file_data = json_decode($read_file,true);
				// echo "<pre>";
				// print_r ($file_data);
				// echo "</pre>";
				if($file_data['track'][$_GET['date']]) {
					foreach ($file_data['track'][$_GET['date']] as $key1 => $value1) {
						$c1++;
						if($_GET['type'] == "lu") {
							$objPHPExcel->getActiveSheet()
				                                    ->setCellValue('A'.$c1, $key1+1)
				                                    ->setCellValue('B'.$c1, $file_data['created_at'])
				                                    ->setCellValue('C'.$c1, $value)
				                                    ->setCellValue('D'.$c1, str_replace("+", " ", $file_data['name']))
				                                    ->setCellValue('E'.$c1, ((isset($file_data['email']))?$file_data['email']:""))
				                                    ->setCellValue('F'.$c1, $value1['pathname'].((isset($value1['search']))?$value1['search']:""))
				                                    ->setCellValue('G'.$c1, ((isset($file_data['country']))?$file_data['country']:""))
				                                    ->setCellValue('H'.$c1, $value1['IP']);
						}else{
							$objPHPExcel->getActiveSheet()
				                                    ->setCellValue('A'.$c1, $key1+1)
				                                    ->setCellValue('B'.$c1, $file_data['created_at'])
				                                    ->setCellValue('C'.$c1, $value)
				                                    ->setCellValue('D'.$c1, $value1['pathname'].((isset($value1['search']))?$value1['search']:""))
				                                    ->setCellValue('E'.$c1, $value1['IP']);
						}
					}
					$c1++;
				}
			}
		}
		$filename='Login-Users-List.xls'; //save our workbook as this file name
        header('Content-Type: application/vnd.ms-excel'); //mime type
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

        // Save it as an excel 2003 file
        $objWriter = IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save("php://output");
	}

	public function usersTrackingRecord()
	{
		$this->is_logged_in();
		if (isset($_GET['date']) && $_GET['date']!="") {
			$file_data = read_file("assets/users/".$_GET['type']."/0/".$_GET['date']."/".$_GET['id'].".json");
			$data['file_data'] = json_decode($file_data,true);
		}
		if($this->admintype == 'tcs') {
			$this->loadTrackerHtml("users-tracking-search-data","Users Tracking Data",$data);
		}else{
			$this->loadTrackerHtml("users-tracking-data","Users Tracking Data",$data);
		}
	}

	public function deleteUsersTrackRecord()
	{
		if(isset($_GET['date']) && $_GET['date']!="") {
			if(is_dir("assets/users/".$_GET['type']."/0/".$_GET['date'])) {
				delete_files(FCPATH ."assets/users/".$_GET['type']."/0/".$_GET['date']);
				rmdir("assets/users/".$_GET['type']."/0/".$_GET['date']);
				redirect(base_url('tracking/userTrackingPage'),'refresh');
			}
		}
	}

	public function test()
	{
		$this->load->view("test");
	}

}

/* End of file tracking.php */
/* Location: .//C/Users/ABC/AppData/Local/Temp/fz3temp-2/tracking.php */