<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class User_Search extends MY_User_Search {

    Public function __construct(){
        parent::__construct();
        $this->is_logged_in();
        //$this->perPage=10;
        $this->load->helper("user_search_helper");
    }

    public function is_logged_in()
    {
        $is_admin_logged_in = $this->session->userdata('is_admin_logged_in');
        if(!isset($is_admin_logged_in) || $is_admin_logged_in != true) {
            
            redirect(base_url("admin-login"));
        }
    }

    public function index()
    {
        $data['user_title'] = $this->config->item("title");
        $data['countryarray'] = $this->config->item("countryarray");
        $data['tender_sector'] = $this->config->item("sector_industry");
        $data['package'] = $this->config->item("package");
        $data['lead_sources'] = $this->config->item("lead_sources");
        $data['hear'] = $this->config->item("hear");
        $data['admins'] = $this->common->getData("admin",array("admin_type !="=>"parent"),array("adminid","admin_name","sub_adminid"));
        $data['admin_type'] = $this->session->userdata('admin_type');
        $data['link'] = base_url("admin/usersearch");
        //echo "<pre>"; print_r($data); print_r($this->session->all_userdata()); die;
        $this->loadAdminHtml("user-search","Users",$data);
    }

    public function advanceUserSearch($limit='')
    {
        $post = $post1 = array();
        $get=array();
        if($limit!="") {

            $post1['limit'] = $limit;
        }else{
            $post['limit'] = 0;
        }
        if(!empty($_POST)) {

            if(isset($_POST["search"]) && $_POST["search"] == 1) {

                unset($_POST["search"],$_POST["submit"]);
                foreach ($_POST as $key => $value) {
                    if($_POST[$key]!="") {

                        $post[$key] = $value;
                    }
                }
                $this->session->set_userdata("usearch",$post);
            }
        }else{
            $post = $this->session->userdata('usearch');
            if($limit!="") {
                
                $post['limit'] = $post1['limit'];
            }
        }
        //echo "<pre>"; print_r($post);die;
        //$this->is_logged_in();
        $searchF = $post['searchF'];
        unset($post['searchF']);
        $data = $this->usearch->advanceUsersSearch($post,base_url('admin/usersearch'),$searchF); //$this->common->getData("user");
        //$this->session->set_userdata('tender_search_query',$this->db->last_query());
        //echo "<pre>"; echo $this->db->last_query(); print_r($data);die;
        $admin_type = $this->session->userdata('admin_type');
        if($admin_type=="parent"){
            $this->loadAdminHtml("usersearch","Users",$data);
        }else{
            $this->loadAdminHtml("admin-alloted-user","admin alloted user",$data);
        }
    }

    public function stepTwoCompleateUserSearch($limit='')
    {
        $post = $post1 = array();
        $get=array();
        if($limit!="") {

            $post1['limit'] = $limit;
        }else{
            $post['limit'] = 0;
        }
        if(!empty($_POST)) {

            if(isset($_POST["search"]) && $_POST["search"] == 1) {

                unset($_POST["search"],$_POST["submit"]);
                foreach ($_POST as $key => $value) {
                    if($_POST[$key]!="") {

                        $post[$key] = $value;
                    }
                }
                $this->session->set_userdata("usearch",$post);
            }
        }else{
            $post = $this->session->userdata('usearch');
            if($limit!="") {
                
                $post['limit'] = $post1['limit'];
            }
        }
        //echo "<pre>"; print_r($post);die;
        //$this->is_logged_in();
        $searchF = "stepTwoCompleateUserSearch";
        unset($post['searchF']);
        $data = $this->usearch->advanceUsersSearch($post,base_url('admin/usersearch'),$searchF); //$this->common->getData("user");
        //$this->session->set_userdata('tender_search_query',$this->db->last_query());
        //echo "<pre>"; echo $this->db->last_query(); print_r($data);die;
        $admin_type = $this->session->userdata('admin_type');
        if($admin_type=="parent"){
            $this->loadAdminHtml("usersearch","Users",$data);
        }else{
            $this->loadAdminHtml("admin-alloted-user","admin alloted user",$data);
        }
    }

    public function suspendUser()
    {
        //print_r($_POST);
        //$this->common->updateData("user",array("suspend"=>$_POST['val']),array("userid"=>$_POST['userid']));
        $this->db->query("update user set suspend = ".$_POST['val']." where userid in (".$_POST['userid'].")");

        header('Content-type: application/json; charset=utf-8"');
        if($this->db->affected_rows())
        {
            echo 1;
        }else{
            echo 0;
        }die;
    }

    public function verifyUser()
    {
        $this->common->updateData("user",array("varify"=>$_POST['val']),array("userid"=>$_POST['userid']));

        if($this->db->affected_rows())
        {
            echo 1;
        }else{
            echo 0;
        }die;
    }

    public function userScheduleMailPage()
    {
        $data['schedule'] = $this->usearch->userScheduleMail(); //$this->common->getData("mail_schedule");
        $this->loadAdminHtml("schedule-mail","Users",$data);
    }

    public function userNotesPage($userid='')
    {
        $where = array();
        if($userid){
            $where = array("UN.userid"=>$userid);
        }
        $data['notes'] = $this->usearch->getUserNotesInfo($where);
        $data['userid'] = $userid;
        //$this->loadAdminHtml("all-users-notes","All Users Notes List",$data);
        $this->loadAdminHtml("users-notes","All Users Notes List",$data);
    }

    public function viewTenderSearch($limit='')
    {
        $post = $post1 = array();
        $get=array();
        /*if($limit!="") {

            $post1['limit'] = $limit;
        }else{
            $post['limit'] = 0;
        }
        if(!empty($_POST)) {

            if(isset($_POST["search"]) && $_POST["search"] == 1) {

                unset($_POST["search"],$_POST["submit"]);
                foreach ($_POST as $key => $value) {
                    if($_POST[$key]!="") {

                        $post[$key] = $value;
                    }
                }
                //$this->session->set_userdata("usearch",$post);
            }
        }else{
            $post = $this->session->userdata('usearch');
            if($limit!="") {
                
                $post['limit'] = $post1['limit'];
            }
        }*/
        //$data = $this->usearch->advanceUsersSearch($post,base_url('admin/viewtendersearch'),"viewTenderSearch"); //$this->common->getData("user");
        $data['tender'] = $this->usearch->viewTenderSearch($_POST); //$this->common->getData("user");
        //$this->session->set_userdata('tender_search_query',$this->db->last_query());
        //echo "<pre>"; echo $this->db->last_query(); print_r($data);die;
        //$admin_type = $this->session->userdata('admin_type');
        $this->loadAdminHtml("view-tender-search-result","View Tender Search Result",$data);
    }

    /* Seen Tenders Code Start */
    public function viewTenderSearchPage($userid='')
    {
        $data['countryarray'] = $this->config->item("countryarray");
        $data['userid'] = $userid;
        $this->loadAdminHtml("view-tender-search","View Tender Search",$data);
    }

    public function userViewedTenders($userid='')
    {
        /*$tenders = $this->common->getsData("saved_history_tenders",array("userid"=>$userid),array("history_tenders"));
        $data['tender'] = json_decode($tenders["history_tenders"]);*/
        if(!$_POST){
            $data['tender'] = $this->usearch->viewTenderSearch(array("userid"=>$userid));//$this->common->getData("seen_tenders",array("userid"=>$userid));
            $data['userid'] = $userid;
        }else{
            $data['tender'] = $this->usearch->viewTenderSearch($_POST);
            $data['userid'] = $_POST['userid'];
        }
        $this->loadAdminHtml('view-tender-search-result','Users Viewed Tenders',$data);
    }
    /* Seen Tenders Code End */
}